#define HRPTLIN_NW
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include "xrit2pic.h"
#include "avhrr.h"

extern GLOBINFO globinfo;
extern PREFER prefer;

struct tm get_time(FILE *fpi,int year)
{
  struct tm tm;
  long t,tp;
  int d,dp;
  int y;
  guint16 l[20];
  memset(&tm,0,sizeof(tm));
  t=tp=0;
  d=dp=-1;
  for (y=0; y<100; y++)
  {
    fseek(fpi,(y*11090 )*2 ,SEEK_SET);
    fread(l,2,12,fpi);
    d=GUINT16_FROM_BE(l[8])>>1;
    t=((GUINT16_FROM_BE(l[9])&0x7f)<<20) + (GUINT16_FROM_BE(l[10])<<10) + (GUINT16_FROM_BE(l[11]));
    if (((t-tp==166) || (t-tp==167)) && (d==dp)) break;
    tp=t;
    dp=d;
  }
  t-=y*167;
  tm.tm_year=year-1900;
  tm.tm_yday=d;
  tm.tm_hour=t/1000/3600;
  tm.tm_min=(t-tm.tm_hour*3600000)/1000/60;
  tm.tm_sec=(t-tm.tm_hour*3600000 - tm.tm_min*60000)/1000;
  yday2mday_mon(&tm);
  return tm;
}

/*************************************
 * Translate avhrr into  guint16 string.
 * Get all 5 channels and
 * connect each of them with a segments in one of 5 chan's.
 *************************************/
int noaa2str(SEGMENT *segm,
             gboolean get_allchan,
             PIC_CHARS *pc)
{
//  static int *xtbl;
  CHANNEL *chan;
  FPFNTMP fpfntmp=clear_fpfntmp();
  guint16 *nstr[AVHRR_NRCHANS];
  guint16 pix[AVHRR_NRCHANS];
  int y,i,x;
  int width,height;
  int iheight;   // height for this segment
//  char fnt[200];
  char chan3ab=0;
  if (segm->chan->nc==0) return -1;
  if (segm->chan->nl==0) return -1;
  
  memset(nstr,0,sizeof(*nstr)*AVHRR_NRCHANS);

  /* Expected size in this segment (see init_noaachars) */  
  width=segm->chan->nc;  // segm->xh.nc;
  height=segm->chan->nl; // segm->xh.nl;
  segm->width=width;  
  segm->height=height; 
  
  /* Bunzip2 into a temp file */
  fpfntmp=cropen_bunzip(segm->pfn);
  if (!fpfntmp.fp)
  {
    segm->corrupt=TRUE;             /* cleared with new generation */
    return Open_Rd;
  }

  // determine channel3: a/b
  fseek(fpfntmp.fp,12,SEEK_SET);
  fread(pix,2,1,fpfntmp.fp);
  chan3ab=(pix[0]&0x0100? 'a' : 'b');
//printf("chan3ab: %c\n",chan3ab);
  /* Determine actual # lines (may be lower for first/last segment)
     HRPT contains 11090 words per line; each word is 2 bytes.
  */
  fseek(fpfntmp.fp,0,SEEK_END);
  iheight=ftell(fpfntmp.fp)/(11090*2);       // actual # lines of this segment

/* first and last segm may have lower amount of lines.
   Make missing lines'black'.
   Startpoint > 0 only for first segment -> ystart
*/
  if (segm->xh.segment==1)
  {
    segm->y_offset=height - iheight;
  }
  else
  {
    segm->y_offset=0;
  }


/*
  Allocate mem for channels to process.
  This is either 1 channel (chan->chan_nr=1...5) or all 5 channels.
*/
  for (chan=segm->chan; chan->prev; chan=chan->prev);
  for (; chan; chan=chan->next)
  {
    nstr[chan->chan_nr-1]=calloc((width*height),2); // cleared array
  }
#ifdef TODO  
//Get actual time from HRPT-data.
  get_time(fpfntmp.fp,year);
#endif

// Laatste segment geeft geen zwart op einde!
/* Draw for actual height. Total height maybe bigger; difference is black. */
  for (y=0; y<iheight; y++)
  {
    fseek(fpfntmp.fp,(y*11090 + 750)*2 ,SEEK_SET);
    for (x=0; x<width; x++)
    {
      /* Read a pixel (all 5 channels) */
      if (!(fread(pix,2,5,fpfntmp.fp))) { x=-1; break; }

      /* Store pix in string. Only for channels for which nstr is allocated. */
      for (i=0; i<AVHRR_NRCHANS; i++)
      {
        if (nstr[i])
          *(nstr[i]+(x+(segm->y_offset+y)*width)*1)=GUINT16_FROM_BE(pix[i]);
      }
    }
    if (x<0) break;       /* EOF; stop */
  }

  rmclose(&fpfntmp);

/* Connect nstr to correct segm for all channels */
  {
    int nrsegm=segm->xh.segment;
    SEGMENT *segml;
    chan=segm->chan;
    while (chan->prev) chan=chan->prev;
    for (; chan; chan=chan->next)
    {
      for (segml=chan->segm; segml; segml=segml->next)
      {
        if (segml->xh.segment==nrsegm)
        {
          segml->chan3_ab=chan3ab;
          if (get_allchan)
          {
            segml->chnk=nstr[chan->chan_nr-1];
            segml->width=width;
            segml->height=height;   // take max. segment height, also if partial filled!
          }
          else
          {
            if (segml==segm)
            {
              segml->chnk=nstr[chan->chan_nr-1];
              segml->width=width;
              segml->height=height;
            }
            else
            {
              free(nstr[chan->chan_nr-1]);
            }
          }
          break;
        }
      }
    }
  }
  return 0;
}

