#include "bzlib.h"

#define BUFLEN 1000
int bunzip2(char *fni,char *fno)
{
  FILE *fpi,*fpo;
  BZFILE *bzfp;
  char buf[BUFLEN];
  int err,m;
  if (!(fpi=fopen(fni,"rb"))) return -1;
  bzfp=BZ2_bzReadOpen(&err,fpi,0,0,NULL,0);
  if (err)
  {
    fclose(fpi);
    return -2;
  }

  if (!(fpo=fopen(fno,"wb")))
  {
    BZ2_bzReadClose(&err,bzfp);
    fclose(fpi);
    return -1;
  }
  while (1)
  {
    m=BZ2_bzRead(&err,bzfp,buf,BUFLEN);
    if (m<=0) break;
    fwrite(buf,sizeof(char),m,fpo);
  }
  BZ2_bzReadClose(&err,bzfp);
  fclose(fpo);
  fclose(fpi);
  return 0;
}
