/*******************************************************************
 * Copyright (C) 2003 R. Alblas 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 ********************************************************************/
#include "xrit2pic.h"
#include "xrit2pic_defines.h"
#include <stdlib.h>
#include <string.h>
extern GLOBINFO globinfo;
extern PREFER prefer;

int dump_data(SEGMENT *segm,guint16 **str)
{
  FILE *fpi;
  XRIT_HDR xrit_hdr1;
  unsigned char c[10];
  guint16 *p;
  int n=0;
  int width,height,depth,nrpixs;
  memset(&xrit_hdr1,0,sizeof(xrit_hdr1));
  if (!(fpi=open_xritimage(segm->pfn,&xrit_hdr1,UNKDTYPE,segm->chan))) return Open_Rd;
  /* NOTE: Not all segm->pxh's are initialized, only first! */
  width=xrit_hdr1.nc;
  height=xrit_hdr1.nl;
  depth=xrit_hdr1.nb;
  nrpixs=width*height;
  if (nrpixs==0) return Open_Rd;
  *str=malloc(nrpixs*sizeof(**str)); // enough for depth=16
  p=*str;

  segm->xh.coff=xrit_hdr1.coff;
  segm->xh.cfac=xrit_hdr1.cfac;
  segm->xh.loff=xrit_hdr1.loff;
  segm->xh.lfac=xrit_hdr1.lfac;
  freed(&xrit_hdr1.img_obs_time);

  if (depth==10)
  {
    int b;

    /*
    01234567 01
    234567 0123
    4567 012345
    67 01234567
    */
    while ((fread(c,5,1,fpi))&&(n<nrpixs))
    {
      for (b=0; b<4; b++)
      {
        *p=((c[b]<<((b+1)*2))&0x3ff)+(c[b+1]>>((3-b)*2));
        p++;
        n++;
      }
    }
  }
  else if (depth==16) // 16 bpp, big endian 
  {
    while ((fread(c,2,1,fpi))&&(n<nrpixs)) { *p=(c[0]<<8)+c[1]; p++; n++; }
  }
  else
  {
    while ((fread(c,1,1,fpi))&&(n<nrpixs)) { *p=c[0]; p++; n++; }
  }
  fclose(fpi);
  segm->width=width;
  segm->height=height;
  return 0;
}


int gen_binitem(GtkWidget *window,GROUP *grp,GENMODES *modes,PREFER *prefer,
                    char *tfno)
{
  int err=0;
  if ((globinfo.nr_pics == 1) || (chan_selected(window,grp->chan->chan_name)))
  {
    if (modes->otype=='v')
    {
      Create_Message("Info","data preview not supported.");
    }
    else
    {
      err=gen_bin(window,grp,prefer,tfno,modes->test);
      if (modes->log_func) modes->log_func(modes,grp,tfno,err);
    }
  }
  return err;
}

int gen_bufritem(GtkWidget *window,GROUP *grp,GENMODES *modes,PREFER *prefer,
                    char *tfno)
{
  int err=0;
  if ((globinfo.nr_pics == 1) || (chan_selected(window,grp->chan->chan_name)))
  {
    if (modes->otype=='v')
    {
#ifndef __NOGUI__
      if (!strcmp(grp->sat_src,"ers2"))
      {
        int n;
        n=open_earthmap1(window,grp);
        if (n<0)
          Set_Entry(window,LAB_INFO,"Translator %s not found!?",prefer->prog_bufrextr); 
        else if (n==0)
          Set_Entry(window,LAB_INFO,"No content in bufr."); 
        else
          Set_Entry(window,LAB_INFO,"Extracted %d points.",n); 
      }
      else
        Create_Message("Info",bufrinfo(grp));
#endif
    }
    else
    {
      err=gen_bufr(window,grp,prefer,tfno,modes->test);
      if (modes->log_func) modes->log_func(modes,grp,tfno,err);
      
    }
  }
  return err;
}

#include "parse_xml.h"
#ifndef __NOGUI__

#define NRCOL 6
#define NRCOLVIS NRCOL-1
#define COLNR 0
#define COLSAT 1
#define COLIMPACT 2
#define COLSTART 3
#define COLEND 4
#define COLDETAIL 5
static void sel_made(GtkWidget *ctree,gpointer data)
{
  GtkCTreeNode *sel_node=(GtkCTreeNode *)data;
  char *text;
  gtk_ctree_node_get_text((GtkCTree *)ctree,sel_node,COLDETAIL,&text);
  if (text)
  {
    GtkWidget *wtxt;
    wtxt=Find_Widget(Find_Parent_Window(ctree),"xx");
    if (wtxt)
    {
      wtxt=wtxt->parent;
      Clear_Text(wtxt);
      Add_Text(wtxt,120,text);
    }
  }
}


static void preview_E_UNS_tree(GtkWidget *wnd,GROUP *grp_sel)
{
  GtkWidget *wdgt[2];
  GtkCTree *ctree;
  FILE *fpi;
  XML *xml,*x1,*x2,*x3;
  char str[NRCOLVIS][300],*w[3],strx[300];
  
  char *tmphdr[NRCOL];
  char *tmp[NRCOL];
  int i;
  if (!grp_sel) return;
  if (!grp_sel->chan) return;
  if (!grp_sel->chan->segm) return;
  if (!grp_sel->chan->segm->pfn) return;

  if (!(fpi=fopen(grp_sel->chan->segm->pfn,"r"))) return;
  Remove_Grps(grp_sel);
  tmphdr[0]="Nr";
  tmphdr[1]="Satellite";
  tmphdr[2]="Impact";
  tmphdr[3]="Start time";
  tmphdr[4]="End time";
  tmphdr[5]="detail";

  xml=parse_xml(fpi);
  fclose(fpi);

  x1=xml;
  if (!x1) return;
  wnd=Create_Window(wnd,600,400,"Announcements",NULL);
  if (!wnd) return;
  ctree=Create_CTree("X",sel_made,NULL,NULL,NULL,NULL,NRCOL,tmphdr);
  wdgt[1]=Create_Text("xx",FALSE,NULL);
  wdgt[0]=Pack(NULL,'v',GTK_WIDGET(ctree)->parent,1,wdgt[1],1,NULL);
  gtk_container_add(GTK_CONTAINER(wnd),wdgt[0]);
  gtk_widget_show(wnd);
//Add_Text(wdgt[1],120,"aap");
  while ((x1=find_tag(x1->next,"announcement")))
  {
    if (find_tag(x1->lower,"satellites"))
    {
      x2=x1->lower;
      while ((x2=find_tag(x2,"satellites")))
      {
        x3=x2->lower;
        *str[COLSAT]=0;
        while ((x3=find_tag(x3,"satellite")))
        {
          sprintf(str[COLSAT],"%s %s     ",str[COLSAT],x3->str);
          x3=x3->next;
        }
        tmp[COLSAT]=str[COLSAT];
       
        x2=x2->next;
      }
    }

    else if (find_tag(x1->lower,"services"))
    {
      x2=x1->lower;
      while ((x2=find_tag(x2,"services")))
      {
        x3=x2->lower;
        while ((x3=find_tag(x3,"operational-service-group")))
        {
          strncpy(strx,x3->extname,300);
          w[0]=strtok(strx,"\"");
          w[0]=strtok(NULL,"\"");
          tmp[0]=w[0];
          x3=x3->next;
        }
        x2=x2->next;
      }
    }

    strncpy(strx,x1->extname,300);
    w[0]=strtok(strx,"\"");
    if (w[0]) do
    {
      if ((w[1]=strtok(NULL,"\"")))
      {
        if (!strcmp(w[0],"ann-number=")) strcpy(str[COLNR],w[1]); 
        if (!strcmp(w[0],"impact=")) strcpy(str[COLIMPACT],w[1]); 
        if (!strcmp(w[0],"start-time="))
        {
          if ((w[2]=strchr(w[1],'T'))) { *w[2]=0; w[2]++; } // time
          sprintf(str[COLSTART],"%s,   %s",w[1],(w[2]? w[2] : ""));
          if (str_ends_with(str[COLSTART],":00"))
          {
            char *p=strrchr(str[COLSTART],':'); *p=0;
          }
          strcat(str[COLSTART],"     ");
        }
        if (!strcmp(w[0],"end-time="))
        {
          if ((w[2]=strchr(w[1],'T'))) { *w[2]=0; w[2]++; }
          sprintf(str[COLEND],"%s,   %s",w[1],(w[2]? w[2] : ""));
          if (str_ends_with(str[COLEND],":00"))
          {
            char *p=strrchr(str[COLEND],':'); *p=0;
          }
        }
      }
      for (i=0; i<NRCOLVIS; i++) tmp[i]=str[i];
    } while ((w[0]=strtok(NULL,"\"")));

    if ((x2=find_tag(x1->lower,"detail"))) tmp[5]=x2->str;

    Add_CLeaf(ctree,NULL,tmp);

  }
  gtk_clist_set_column_visibility((GtkCList *)ctree,COLDETAIL,FALSE);;

  Remove_XMLTags(xml);
}

#define SHOW_AS_TREE
#ifndef SHOW_AS_TREE
static void add_xmlmessage(FILE *fpi,GtkWidget *text)
{
  XML *xml,*x1,*x2,*x3;
  char str[300],*w[3];
  xml=parse_xml(fpi);
  x1=xml;
  if (!x1) return;
  while ((x1=find_tag(x1->next,"announcement")))
  {
    if (find_tag(x1->lower,"satellites"))
    {
      x2=x1->lower;
      while ((x2=find_tag(x2,"satellites")))
      {
        x3=x2->lower;
        while ((x3=find_tag(x3,"satellite")))
        {
          Add_Text(text,120,"%s ",x3->str);
          x3=x3->next;
        }
        x2=x2->next;
      }
    }
    else if (find_tag(x1->lower,"services"))
    {
      x2=x1->lower;
      Add_Text(text,120,"\n");
      while ((x2=find_tag(x2,"services")))
      {
        x3=x2->lower;
        while ((x3=find_tag(x3,"operational-service-group")))
        {
          strncpy(str,x3->extname,300);
          w[0]=strtok(str,"\"");
          w[0]=strtok(NULL,"\"");
          Add_Text(text,120,"  %s ",w[0]);
          x3=x3->next;
        }
        x2=x2->next;
      }
    }
    Add_Text(text,120,"\n");
    strncpy(str,x1->extname,300);
    w[0]=strtok(str,"\"");
    if (w[0]) do
    {
      if ((w[1]=strtok(NULL,"\"")))
      {
//        if (!strcmp(w[0],"ann-subject=")) printf("  %s: ",w[1]);
        if (!strcmp(w[0],"impact="))        Add_Text(text,120,"  %s\n",w[1]); 
//        if (!strcmp(w[0],"ann-type="))    printf("  %s\n",w[1]);
        if (!strcmp(w[0],"start-time="))
        {
          if ((w[2]=strchr(w[1],'T'))) { *w[2]=0; w[2]++; }
          Add_Text(text,120,"    From %s, %s\n",w[1],(w[2]? w[2] : ""));
        }
        if (!strcmp(w[0],"end-time="))
        {
          if ((w[2]=strchr(w[1],'T'))) { *w[2]=0; w[2]++; }
          Add_Text(text,120,"    To   %s, %s\n",w[1],(w[2]? w[2] : ""));
        }
      }
    } while ((w[0]=strtok(NULL,"\"")));
//    printf("%s\n",x1->extname);
    if ((x2=find_tag(x1->lower,"detail"))) Add_Text(text,120,"  Details: %s",x2->str);
    Add_Text(text,120,"\n--------------------------------------------\n");
  }
}
#endif
static void add_asciimessage(FILE *fpi,GtkWidget *text)
{
  char l[1000];
  while (fgets(l+1,1000,fpi))
  {
    l[0]=' ';
    l[strlen(l)-2]='\n';
    l[strlen(l)-1]=0;
    Add_Text(text,120,l);
  }
}
#endif

static int extract_file(SEGMENT *segm,char *tfno)
{
  XRIT_HDR xrit_hdr1;
  FILE *fpi,*fpo;
  char l[200];
  if (!(fpi=open_xritimage(segm->pfn,&xrit_hdr1,UNKDTYPE,segm->chan))) return Open_Rd;
  if (!(fpo=fopen(tfno,"w"))) return Open_Wr;
  while (fgets(l,200,fpi)) fprintf(fpo,l);
  fclose(fpi);
  fclose(fpo);
  return 0;
}

int gen_admin_item(GtkWidget *window,GROUP *grp_sel,GENMODES *modes,PREFER *prefer,
                    char *tfno,gboolean *grp_ready)
{
#ifndef __NOGUI__
  GtkWidget *list_wnd=Find_Window(window,LAB_PROGRESS_TRANS);
#endif
  int err=0;

  /* Do now if just 1 item to be done or if this item is selected in list-window. */
  /* Use ID to determine selected item in list-window. */
  if ((globinfo.nr_pics == 1) || (chan_selected(window,grp_sel->chan->chan_name)))
  {
#ifndef __NOGUI__
    Set_Led(list_wnd,grp_sel->chan->id,0xff0); /* yellow */
    Set_Led(list_wnd,grp_sel->id,0xff0);       /* yellow */
#endif

    if (modes->otype=='v')
    {
#ifndef __NOGUI__
      if (str_ends_with(grp_sel->chan->segm->pfn,".xml"))
#ifdef SHOW_AS_TREE
        preview_E_UNS_tree(window,grp_sel); /* Do it! */
#else
        preview_admin(grp_sel,add_xmlmessage); /* Do it! */
#endif
      else
        preview_admin(grp_sel,add_asciimessage); /* Do it! */
#endif
      *grp_ready=FALSE;                        /* Remove_Grps done by preview! */
    }
    else
    {
      char *p;
      make_destdir1(prefer->dest_dir,&grp_sel->pc,tfno);
      strcat(tfno,grp_sel->chan->segm->fn);
      if ((p=strrchr(tfno,'.'))) strcpy(p,".txt");
      err=extract_file(grp_sel->chan->segm,tfno);
//      err=copy_file(grp_sel->chan->segm->pfn,tfno);
      if (modes->log_func) modes->log_func(modes,grp_sel,tfno,0);
    }
    if (!err)
    {
#ifndef __NOGUI__
      Set_Led(list_wnd,grp_sel->chan->id,0x0f0); /* green*/
      Set_Led(list_wnd,grp_sel->id,0x0f0);       /* green*/
#endif
    }
  }
  else
  {
    *grp_ready=TRUE;
  }
  return err;
}

