/*******************************************************************
 * Copyright (C) 2003 R. Alblas 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 ********************************************************************/
#include "xrit2pic.h"
#include "xrit2pic_defines.h"
#include <string.h>

extern GLOBINFO globinfo;


/***********************************************
 * Generate admin file
 ***********************************************/
int gen_admin(GtkWidget *window,GROUP *grp_sel,PREFER *prefer)
{
  FILE *fpi,*fpo;
  char tfno[1000];
  char *fn=grp_sel->chan->segm->pfn;
  char *ext=".txt";
  PIC_CHARS *pc=&grp_sel->pc;
  if (!(fpi=open_xritimage(fn,NULL,EXRIT,NULL))) return Open_Rd;

  make_filename1(prefer->dest_dir,pc,ext,tfno,NULL,prefer->split_destdir);

  if (overwrite(tfno,globinfo.overwrite_mode))
  {
    if ((fpo=fopen(tfno,"w")))
    {
      char l[1000];

      while (fgets(l,1000,fpi))
      {
        l[strlen(l)-2]='\n';
        l[strlen(l)-1]=0;
        fprintf(fpo,"%s",l);
      }
      fclose(fpo);
      Set_Entry(window,LAB_INFO,"Created: %s%s",pc->picname,ext);
    }
    else
    {
      return Open_Wr;
    }
  }
  else
  {
    Set_Entry(window,LAB_INFO,"Exist: %s%s",pc->picname,ext);
  }

  fclose(fpi);
  return 0;
}


/* Extract as raw data */
int gen_bin(GtkWidget *window,GROUP *grp_sel,PREFER *prefer,char *tfno,gboolean test)
{
  FILE *fpi,*fpo;
  SEGMENT *segm;
  char *fn;
  char *ext=".bin";
  PIC_CHARS *pc=&grp_sel->pc;
  if ((!grp_sel->chan) || (!grp_sel->chan->segm)) return 1;
  fn=grp_sel->chan->segm->pfn;
  if (!(fpi=open_xritimage(fn,NULL,UNKDTYPE,NULL))) return Open_Rd;
  fclose(fpi);

  make_filename1(prefer->dest_dir,pc,ext,tfno,NULL,prefer->split_destdir);
  if (test) return 0;

  if (overwrite(tfno,globinfo.overwrite_mode))
  {
    if (!(fpo=fopen(tfno,"wb"))) return Open_Wr;
    
    for (segm=grp_sel->chan->segm; segm; segm=segm->next)
    {
      int c;
      fn=segm->pfn;
      if (!(fpi=open_xritimage(fn,NULL,UNKDTYPE,NULL)))
      {
        Create_Message("ERROR","Missing file: %s.",fn);
        continue;
      }
      while ((c=fgetc(fpi))!=EOF) fputc(c,fpo);
      fclose(fpi);
    }
    fclose(fpo);
    Set_Entry(window,LAB_INFO,"Created: %s%s.",pc->picname,ext); 
  }
  else
  {
    Set_Entry(window,LAB_INFO,"Exist: %s%s.",pc->picname,ext);
  }

  return 0;
}

int gen_bufr(GtkWidget *window,GROUP *grp_sel,PREFER *prefer,char *tfno,gboolean test)
{
  FILE *fpi;
  char *fn,*p;
  char *errmess;
  int nrp=0;
  PIC_CHARS *pc=&grp_sel->pc;
  if ((!grp_sel->chan) || (!grp_sel->chan->segm)) return 1;
  fn=grp_sel->chan->segm->pfn;
  if (!(fpi=open_xritimage(fn,NULL,BUFR,NULL))) return Open_Rd;
  fclose(fpi);

#ifdef EXTRACT_SUBBUFR
  strcpy(pc->fno,grp_sel->chan->segm->fn);
  make_filename1(prefer->dest_dir,pc,NULL,tfno,NULL,prefer->split_destdir);
  if (test) return 0;
  if ((fpi=fopen(fn,"rb")))
  {
    char *ext=".bufr";
    int n;
    n=extract_bufr(fpi,tfno,ext);
    fclose(fpi);
    Set_Entry(window,LAB_INFO,"Extracted: %d bufr parts from %s.",n,grp_sel->chan->chan_name); 
  }
#else
  strcpy(pc->fno,grp_sel->chan->segm->fn);
  if ((p=strrchr(pc->fno,'.'))) *p=0;
  strcat(pc->fno,".txt");
  make_filename1(prefer->dest_dir,pc,NULL,tfno,NULL,prefer->split_destdir);
  errmess=scat_extract_to(fn,tfno,&nrp);

  if (!errmess)
  {
    Set_Entry(window,LAB_INFO,"Translation failed!"); 
  }
  else if (*errmess)
  {
    Set_Entry(window,LAB_INFO,"%s",errmess); 
  }
  else
  {
    char *p;
    if ((p=strrchr(tfno,DIR_SEPARATOR))) p++; else p=tfno;
    Set_Entry(window,LAB_INFO,"Extracted %d points to %s.",nrp,p); 
  }

#endif  
  return 0;
}
