/*******************************************************************
 * Copyright (C) 2003 R. Alblas 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 ********************************************************************/
#include <malloc.h>

#include <string.h>
#include <stdlib.h>
#include "xrit2pic.h"
#include "xrit2pic_defines.h"
#include "gtk/gtk.h"
#include "xrit_prefs.h"

#define LAB_UPDATE "1x  "
#define LAB_NOTIFY "MSG Notify"

#define PART_REMOVEITEMS "Delete next items"
#define LAB_REMOVECHAN "Delete items"
#define LAB_SHOWNEW "Show"
#define LAB_SHOWCLR "Colour"
#define LAB_FIREDET "Fire"
#define LAB_SHOWGAM "Gamma"
#define LAB_SHOWHRVLUM "Hrv lum"
#define LAB_SHOWOL "Overlay   "
#define LAB_SHOWLL "Lon/lat   "
#define LAB_SHOWMRK "Mark   "
#define LAB_SHOWCIT "Cities   "
#define LAB_SHOWTIM "Time"
#define LAB_SHOWTXT1 "Text 1"
#define LAB_SHOWTXT2 "Text 2"

//This removed, should be done with lum_min/lum_max
//#define LAB_SHOWLUM "^Brightness"
#define LAB_MAPCLR "Colour Map"

#define LAB_LGEN "Enable   "
#define LAB_RMALL "Remove raw data"
#define LAB_GENFILE "Files only"
#define LAB_GENMOV "Movie"
#define LAB_RMJPEG "!Remove jpeg             "
#define LAB_RUNCMD1 "Run command"
#define LAB_ESSENTIAL "msg_essential"
#define LAB_REGEL "Manage files"

#define LAB_RECEIVE "Record"

#define LAB_LISTRECEIVED "List Received"

#define AFTERREC_SET "ARECSET"
#define AFTERREC_DEL "ARECDEL"
#define SHOWLIVE "SHOWLIVE"
#define LAB_UNKNOWN "Unknown"
#define LAB_CDDELRUNNEXT "Delete info:"
#define LAB_DELTIME "Del. older than" 
#define LAB_DELOLDIND "Old"
#define LAB_DELITEMS "Items"
#define LAB_GENPICIND "Pics"
#define LAB_GENMOVIND "Movie "

#define BOX_MOVIE "Movie items"

// See nb_prefs: 
#define LAB_STORESETTINGS "Store"
#define LAB_MOVIEUSE      "Use std\ncommand/Construct\ncommand"
#define LAB_MOVIEOPT      "Movie options"
#define LAB_SPEED         "! Speed:\n Min./sec."
#define LAB_FULLSCR       "!Full screen"
#define LAB_SHOW_RERUNCMD "!SHRERUN"

extern XRIT_DBASE dbase;
extern GLOBINFO globinfo;
extern PREFER prefer;
extern GROUP *globgrp;

// check if mplayer exist. (Linux)
static int found_program(char *cmd)
{
  char *prog=NULL,*p;
  int ret=0;
#if __GTK_WIN32__ != 1
  sprintfd(&prog,"type %s",cmd);
  if ((p=strchr(prog+5,' '))) *p=0;
  strcatd(&prog," > /dev/null 2>&1");
  ret=system(prog);
  freed(&prog);
#endif
  return ret; 
}

// what: 0=stop/start, 1=start, 2=stop
void grerun_script(GtkWidget *widget,int what)
{
  int ret;                      // run user-script
  if (found_program(globinfo.rerun_cmd)) return; 
  // spawn_prog with non-ex. prog causes xrit2pic to crash...???
  ret=rerun_script(globinfo.rerun_cmd,what);
  if ((widget) && (what!=2))
  {
    if (ret<=0) Set_Entry(widget,LAB_INFO,"Failed: %s.",globinfo.rerun_cmd);
    else        Set_Entry(widget,LAB_INFO,"Cmd: %s.",globinfo.rerun_cmd);
  }
}

/* Load channelmapping requested for generation. (Not for 'live' pic.) */
static void load_chanmap(GENMODES *gmode,char *chan_name)
{
  if (gmode->chanmap) Remove_Chanmap(&gmode->chanmap);
  if (gmode->spm.compose)
  {
    gmode->chanmap=Copy_Chanmap(globinfo.pixmap_gen.chanmap);

    if (gmode->use_hrv_lum)
    {
      CHANMAP *cm;
      cm=Create_Chanmap(&gmode->chanmap,"HRV",0.,0.,0.,FALSE);
      cm->lum=TRUE;
    }
  }
  else
  {
    Create_Chanmap(&gmode->chanmap,chan_name,1.,1.,1.,FALSE);
  }
}
static char *handle_spaces1(char *si)
{
  char *so,*po,*pi;
  int len=strlen(si);

  for (pi=si; *pi; pi++) if (*pi==' ') len++;
  so=calloc(len+1,1);
  po=so;
  for (pi=si,po=so; *pi; po++,pi++)
  {
    if (*pi==' ') {*po='\\'; po++;}
    *po=*pi;
  }
  return so;
}



static gboolean loadlistfunc(GtkWidget *widget,gboolean move_avhrr,gboolean show_new)
{
  static int n;
  static int v;

  char vv[]="|/-\\";

  Set_Entry(widget,LAB_NUPDATE,"%-4d  ...",n);

/* set to 'All'; otherwise tree not properly shown (to be fixed) */
  globinfo.vis_mode=S_all; 
  if ((Get_Optionsmenu(widget,LAB_VIS))!=0) /* to prevent unnecess. redraw */
    Set_Optionsmenu(widget,LAB_VIS,0);

/* In LoadList: pass NULL on widget arg. to disable progress funcs etc. */
  globgrp=Load_List(globgrp,dbase.main_tree,widget,globinfo.pl.src_dir,FALSE,in_received,TRUE,NULL);
  n+=Process_Segm(widget,NULL,globgrp,globinfo.move_to_done,move_avhrr,show_new); //,pixmap);
  if (globinfo.gen_new)
  {
    GENMODES gmode;
    memset(&gmode,0,sizeof(gmode));
//    gmode.gen_film=globinfo.gen_movienew;
    gmode.gen_film=globinfo.pr.lvg_pic0_movie1;
    gmode.spm.compose=globinfo.pr.lv_clr.compose;
    gmode.use_hrv_lum=globinfo.pr.lv_clr.hrv_lum;
    load_chanmap(&gmode,globinfo.pr.lv_chan);  // no colour: gmode->chanmap rgb=(1,1,1)
    gmode.area_nr=globinfo.area_nr;
    if (gmode.gen_film)
      gmode.cformat=PIC_JPEG;
    else
      gmode.cformat=get_picformat(widget);

    gmode.overwrite_mode=OVRWR_REPLACE;
    gmode.filmframe_ovrwrmode=OVRWR_REPLACE;
    gmode.run_script=globinfo.pr.lvg_run_script;            // Get_Button(widget,LAB_RUNCMD1);   // run command after pic is generated
    gmode.rerun_script=globinfo.pr.lvg_rerun_script;            // Get_Button(widget,LAB_RUNCMD1);   // run command after pic is generated
    gmode.essential_only=globinfo.pr.lvg_essential_only;    // Get_Button(widget,LAB_ESSENTIAL);

    gmode.wnd_clrmap=LAB_COLORFIX;
    auto_translate(&gmode,globgrp,&prefer,widget);                         /* Translate pics */
  }
  
  Set_Entry(widget,LAB_NUPDATE,"%-4d  %c",n,vv[v]);
  v++; if (v>=4) v=0;

  return TRUE;
}

static char *pri_curtime(int hoffset)
{
  time_t time2;
  static char s[20];
  struct tm tm;
  time(&time2);
  tm=*gmtime(&time2);
  tm.tm_hour+=hoffset;
  mktime_ntz(&tm);
  strftime(s,15,"%b %d %H:%M",&tm);
  return s;
}

static int charlistlen(char **s)
{
  int i;
  for (i=0; s[i]; i++);
  return i;
}

// run to delete files older than prefer.deldaymin, newer than prefer.deldaymax, 
//   round to days if prefer.roundday
// each run checks if something needs to be deleted

static gboolean dellistoldcont(GtkWidget *widget)
{
  static int prev_time_last_rec;
  int n;

  if ((!prefer.roundday) || (prev_time_last_rec > globinfo.time_last_rec)) // time_last_rec=last recorded UTC hour
  {
    gtk_clist_freeze((GtkCList *)dbase.main_tree);
    n=delete_old(&globgrp,dbase.main_tree,prefer.deldaymin,prefer.deldaymax,prefer.roundday);
    gtk_clist_thaw((GtkCList *)dbase.main_tree);
  
    Set_Entry(widget,LAB_CDDELRUNNEXT,"next at %s.",pri_curtime(prefer.roundday? 24 : 1));
    Set_Entry(widget,LAB_RECINFO,"Deleted %d items.",n);
    Set_Entry(widget,LAB_DELTIME,"%d days, %d hours",prefer.deldaymin[0],(prefer.roundday? 0 : prefer.deldaymin[1]));
  }
  prev_time_last_rec=globinfo.time_last_rec;

  return TRUE;
}

static gboolean loadlistcont(GtkWidget *widget)
{
  static int cnt;
  int ret;
  if (globinfo.busy_gen)
  {
    Set_Widgetcolor(Find_Widget(widget,LAB_CRLOAD),'b',0xff,0xff,0);   // button 'yellow'
    cnt=1;
    return TRUE;
  }
  if (cnt>0)
  {
    Set_Widgetcolor(Find_Widget(widget,LAB_CRLOAD),'b',0xff,0xff,0);   // button 'yellow'
    cnt--;
    Set_Widgetcolor(Find_Widget(widget,LAB_CRLOAD),'b',0xff,0,0);   // button 'red'
    return TRUE;
  }

  globinfo.busy_gen=TRUE;
  ret=loadlistfunc(widget,FALSE,globinfo.pr.lvs_enable);
  globinfo.busy_gen=FALSE;

  return ret;
}

static char *showname2name(char *showname)
{
  SATLIST *sl;
  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    if (sl->show_name)
    {
      if (!strcmpd(showname,sl->show_name)) return sl->name;
    }
    else
    {
      if (!strcmpd(showname,sl->name)) return sl->name;
    }
  }
  return NULL;
}

char *name2showname(char *name)
{
  SATLIST *sl;
  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    if (sl->show_name)
    {
      if (!strcmpd(name,sl->name)) return sl->show_name;
    }
    else
    {
      if (!strcmpd(name,sl->name)) return sl->name;
    }
  }
  return NULL;
}

extern PREFITEMS *pf;

// LAB_SAVE equal to LAB_SAVE in nb_prefs.c
#define LAB_SAVE "Save"
static void do_recordbut_common(GtkWidget *widget,gpointer data)
{
  char *name=(char *)data;
  if (!strcmp(name,LAB_UPDATE))
  {
    loadlistcont(widget);
  }
  if (!strcmp(name,LAB_CRLOAD))
  {
    static int to=0;
    if ((Update_Togglelabel(widget)) && (!to))
    {
      globinfo.pr.record_at_start=TRUE;
      Set_Entry(widget,LAB_RECINFO,"");
      for (dbase.grp_last=globgrp; 
           (dbase.grp_last) && (dbase.grp_last->next); 
           dbase.grp_last=dbase.grp_last->next);
           
      Set_Widgetcolor(widget,'b',0xff,0,0);   // button 'red'
      Set_Widgetcolor(Find_Widget(widget,AFTERREC_SET),'b',0xff,0,0);  // border red
      Set_Widgetcolor(Find_Widget(widget,AFTERREC_DEL),'b',0xff,0,0);  // border red
      Set_Widgetcolor(Find_Widget(widget,SHOWLIVE)    ,'b',0xff,0,0);  // border red
//      Sense_Button(widget,LAB_MAKE,FALSE);    // prevent export during record!
//      Sense_Button(widget,LAB_PREVIEW,FALSE); // prevent preview during record! (something wrong...)
      if (prefer.upd_cycle)
      {
        loadlistfunc(widget,TRUE,FALSE);  // do 1 run to move all data to 'done'
        to=gtk_timeout_add(prefer.upd_cycle*1000,(GtkFunction)loadlistcont,widget);
      }
    }
    else
    {
      globinfo.pr.record_at_start=FALSE;
      Set_Widgetcolor(widget,'b',0xe0,0xe0,0xe0);
      Set_Widgetcolor(Find_Widget(widget,AFTERREC_SET),'b',0,0,0x00);  // border black
      Set_Widgetcolor(Find_Widget(widget,AFTERREC_DEL),'b',0,0,0x00);  // border black
      Set_Widgetcolor(Find_Widget(widget,SHOWLIVE)    ,'b',0,0,0x00);  // border black
      if (to) gtk_timeout_remove(to); to=0;
//      Sense_Button(widget,LAB_MAKE,TRUE);
//      Sense_Button(widget,LAB_PREVIEW,TRUE); 
    }
  }
  if (!strcmp(name,LAB_SAVE))
  {
    prefer.pr=globinfo.pr;
//    Set_Widgetcolor(widget,'b',0xff,0xff,0);
    do_prefbut(widget,LAB_SAVE);
  }
}

static void create_contmoviecommand(SATLIST *sl)
{
  char *aviname=create_aviname(globinfo.area_nr);
  char *destdir=NULL;
  destdir=handle_spaces1(prefer.dest_dir);
  int fps=speed_minpsec2fps(sl,globinfo.pr.lvg_movie_speed);

#if __GTK_WIN32__ == 1
  sprintf(globinfo.rerun_cmd,"\"%s\" %s%s -quiet -fps %d %s -loop 0",
    prefer.prog_playmovie,
    destdir,
    aviname,
    fps,        //lvg_movie_speed=60: fps= 60/15=4, 60/5=12 ==> min/sec
    (globinfo.pr.lvg_movie_fullscreen? "-fs" : ""));
#else
  sprintf(globinfo.rerun_cmd,"%s %s%s -quiet -fps %d %s -loop 0",
    prefer.prog_playmovie,
    destdir,
    aviname,
    fps,        //lvg_movie_speed=60: fps= 60/15=4, 60/5=12 ==> min/sec
    (globinfo.pr.lvg_movie_fullscreen? "-fs" : ""));
#endif
  freed(&aviname);
}

static void update_moviecommand(GtkWidget *widget,SATLIST *sl)
{
  if (!widget) return;
  if (Get_Button(widget,LAB_MOVIEUSE)) create_contmoviecommand(sl);
  Set_Entry(widget,LAB_SHOW_RERUNCMD,"%s",globinfo.rerun_cmd);
}

// detect that a new satellite is selected; return satlist of this new sat
static SATLIST *new_sat_selected(char *name1,int area_nr)
{
  SATLIST *sl;
  static char iname[30];
  static char iarea_nr;
  if (!name1) return NULL;
  if ((!strcmp(name1,iname)) && (area_nr==iarea_nr)) return NULL;
  strcpy(iname,name1);
  iarea_nr=area_nr;
  sl=Get_Satlist_Item(globinfo.satlist,SATLIST_NAME,name1);
  strcpy(globinfo.pr.lv_sat,name1);
  return sl;
}

// update settings if new sat is selected:
//   colour mapping from fixed settings
//   movie command
// 'name'=name shown in gui, converted to full name before comparison
SATLIST *update_newsat_selected(char *name,GtkWidget *widget)
{
  // Get satellite to update 'live'
  SATLIST *sl;
  static char *name1; 
  char *name2=NULL;
  if (name) name2=showname2name(name);
  if (name2) name1=name2;
  if ((sl=new_sat_selected(name1,globinfo.area_nr)))
  {
    set_mapping_from_fixed(sl->defmap_id,&globinfo.pixmap_live);
    update_moviecommand(widget,sl);
  }
  return sl;
}


void Set_Update_channel(GtkWidget *widget)
{
  SATLIST *chan;
  SATLIST *sl=Get_Satlist_Item(globinfo.satlist,SATLIST_NAME,globinfo.pr.lv_sat);
  int n=0;
  if (!sl) return;
  for (chan=sl->chans; chan; chan=chan->next)
  {
    if (!strcmp(chan->name,prefer.pr.lv_chan))
    {
      Set_Optionsmenu(widget,LAB_SHOWCHAN,n);
      break;
    }
    n++;
  }
}


static void do_recordbut_live(GtkWidget *widget,gpointer data)
{
  char *name=(char *)data;

  if (!strcmp(name,LAB_SHOWNEW))
  {
    if (Get_Button(widget,LAB_SHOWNEW))
      globinfo.pr.lvs_enable=TRUE;
    else
      globinfo.pr.lvs_enable=FALSE;
  }

  if (!strcmp(name,LAB_SHOWCLR))
  {
    if (Get_Button(widget,LAB_SHOWCLR))
      globinfo.pr.lv_clr.compose=TRUE;
    else
      globinfo.pr.lv_clr.compose=FALSE;
  }  
  if (!strcmp(name,LAB_FIREDET))
  {
    if (Get_Button(widget,LAB_FIREDET))
      globinfo.pr.lvg_fire_detect=TRUE;
    else
      globinfo.pr.lvg_fire_detect=FALSE;
  }  

  if (!strcmp(name,LAB_SHOWHRVLUM))
  {
    if (Get_Button(widget,LAB_SHOWHRVLUM))
      globinfo.pr.lv_clr.hrv_lum=TRUE;
    else
      globinfo.pr.lv_clr.hrv_lum=FALSE;
  }  

  if (!strcmp(name,LAB_SHOWOL))
  {
    if (Get_Button(widget,LAB_SHOWOL))
      globinfo.pr.lv_ol.add_overlay=TRUE;
    else
      globinfo.pr.lv_ol.add_overlay=FALSE;
  }
  if (!strcmp(name,LAB_SHOWLL))
  {
    if (Get_Button(widget,LAB_SHOWLL))
      globinfo.pr.lv_ol.add_lonlat=TRUE;
    else
      globinfo.pr.lv_ol.add_lonlat=FALSE;
  }

  if (!strcmp(name,LAB_SHOWMRK))
  {
    if (Get_Button(widget,LAB_SHOWMRK))
      globinfo.pr.lv_ol.add_marks=TRUE;
    else
      globinfo.pr.lv_ol.add_marks=FALSE;
  }
  if (!strcmp(name,LAB_SHOWCIT))
  {
    if (Get_Button(widget,LAB_SHOWCIT))
      globinfo.pr.lv_ol.add_cities=TRUE;
    else
      globinfo.pr.lv_ol.add_cities=FALSE;
  }
  
  if (!strcmp(name,LAB_SHOWTIM))
  {
    globinfo.pr.lv_ol.annotxt[0].enable=Get_Button(widget,LAB_SHOWTIM);
  }

  if (!strcmp(name,LAB_SHOWTXT1))
  {
    globinfo.pr.lv_ol.annotxt[1].enable=Get_Button(widget,LAB_SHOWTXT1);
  }

  if (!strcmp(name,LAB_SHOWTXT2))
  {
    globinfo.pr.lv_ol.annotxt[2].enable=Get_Button(widget,LAB_SHOWTXT2);
  }

  if (!strcmp(name,LAB_SHOWGAM))
  {
    globinfo.pr.lvg_gamma=(float)Get_Adjust(widget,LAB_SHOWGAM);
  }

  if (!strcmp(name,LAB_SHOWCHAN2))
  {
    strcpy(globinfo.pr.lv_chan,Get_Entry(widget,LAB_SHOWCHAN2));
  }
  {
    char *opt;
    opt=soption_menu_get_history(Find_Widget(widget,LAB_SHOWCHAN));
    if ((opt) && (!strcmp(name,opt)))         /* suppress deselect */
      Set_Entry(widget,LAB_SHOWCHAN2,opt);
  }
  if (!strcmp(name,LAB_MAPCLR))
  {
    GtkWidget *wnd=Find_Parent_Window(widget);
    SATLIST *sl;
    sl=Get_Satlist_Item(globinfo.satlist,SATLIST_NAME,globinfo.pr.lv_sat);
    color_map_fixed(wnd,&globinfo.pixmap_live,(sl? sl->chans : NULL));
  }

  if (!strcmp(name,LAB_SHOWNEW))
    Sense_Button(widget,LAB_SHOWCLR,globinfo.pr.lvs_enable);

  if ((!strcmp(name,LAB_SHOWNEW)) || (!strcmp(name,LAB_SHOWCLR)))
  {
    Sense_Button(widget,LAB_SHOWCHAN,globinfo.pr.lvs_enable & !globinfo.pr.lv_clr.compose);   
    Sense_Button(widget,LAB_SHOWCHAN2,globinfo.pr.lvs_enable & !globinfo.pr.lv_clr.compose);  
    Sense_Button(widget,LAB_SHOWSAT,globinfo.pr.lvs_enable);
    Sense_Button(widget,LAB_MAPCLR,globinfo.pr.lvs_enable & globinfo.pr.lv_clr.compose);
  }
  set_mapping_from_fixed_this(widget,globinfo.pm.clrmapfixed,get_sattype_live(),&globinfo.pixmap_gen);
}

static void do_recordbut_chansel(GtkWidget *widget,gpointer data)
{
  GtkWidget *wnd=Find_Parent_Window(widget);
  char *name=(char *)data;
  SATLIST *sl;
  if ((sl=update_newsat_selected(name,widget)))
  {
    Remove_Options(Find_Widget(widget,LAB_SHOWCHAN),0);
    if (sl->chans)
    {
      char **chl=chan2strlist(sl->chans);
      Add_Options(widget,LAB_SHOWCHAN,do_recordbut_live,0,chl,charlistlen(chl),0);
    }

    // if colour map window was open: re-open it
    if (Find_Window(wnd,LAB_COLORFIX))
    {
      color_map_fixed(wnd,&globinfo.pixmap_live,NULL);
      color_map_fixed(wnd,&globinfo.pixmap_live,(sl? sl->chans : NULL));
    }
  }
}


static void do_recordbut_gen(GtkWidget *widget,gpointer data)
{
  char *name=(char *)data;
  if (!strcmp(name,LAB_CDELOLD))
  {
    static int to=0;
    if ((Update_Togglelabel(widget)) && (!to))
    {           
      Set_Widgetcolor(widget,'b',0xff,0,0);
      Set_Led(widget,LAB_DELOLDIND,0xf00);

      Set_Entry(widget,LAB_CDDELRUNNEXT,"next after %s.",(prefer.roundday? "0:00" : pri_curtime(1)));
      Set_Entry(widget,LAB_DELTIME,"%d days, %d hours",prefer.deldaymin[0],(prefer.roundday? 0 : prefer.deldaymin[1]));

      to=gtk_timeout_add(3600*1000,(GtkFunction)dellistoldcont,widget); // try each hour
      globinfo.pr.delete_old_at_start=TRUE;
    }
    else
    {
      Set_Widgetcolor(widget,'b',0xe0,0xe0,0xe0);
      Set_Led(widget,LAB_DELOLDIND,0x000);
      if (to) gtk_timeout_remove(to); to=0;
      globinfo.pr.delete_old_at_start=FALSE;
    }
  }
  if (!strcmp(name,LAB_LGEN))
  {
    globinfo.gen_new=Get_Button(widget,LAB_LGEN);
    globinfo.pr.lvg_enable=globinfo.gen_new;

    /* Clear all 'new' flags if gen_new mode switched off */
    if (!globinfo.gen_new)
    {
      GROUP *grp;
      for (grp=globgrp; grp; grp=grp->next)
        grp->new=FALSE;
    }
  }

  if (!strcmp(name,LAB_RUNCMD1))
  {
    globinfo.pr.lvg_run_script=Get_Button(widget,LAB_RUNCMD1);
  }
  if (!strcmp(name,LAB_RUNCMD2))
  {
    gboolean active=Get_Button(widget,LAB_RUNCMD2);
    if (active) grerun_script(widget,1); // als globinfo.rerun_cmd niet uit te voeren dan crash???
    globinfo.pr.lvg_rerun_script=active;
    if (!active) grerun_script(widget,2);
  }
  if (!strcmp(name,LAB_GENFILE))
  {
    globinfo.pr.lvg_pic0_movie1=FALSE;
    Sense_Button(widget,BOX_MOVIE,FALSE);
  }
  if (!strcmp(name,LAB_GENMOV))
  {
    globinfo.pr.lvg_pic0_movie1=TRUE;
    Sense_Button(widget,BOX_MOVIE,TRUE);
    Set_Button(widget,LAB_RMJPEG,TRUE);
  }

  if (!strcmp(name,LAB_ESSENTIAL))
  {
    globinfo.pr.lvg_essential_only=Get_Button(widget,LAB_ESSENTIAL);
  }
  if (!strcmp(name,LAB_RMJPEG))
  {
    globinfo.pr.lvg_movie_rmjpeg=Get_Button(widget,LAB_RMJPEG);
  }

  if ((globinfo.pr.lvg_pic0_movie1) && (globinfo.gen_new))
    Set_Led(widget,LAB_GENMOVIND,0xf00);
  else
    Set_Led(widget,LAB_GENMOVIND,0x000);

  if ((!globinfo.pr.lvg_pic0_movie1) && (globinfo.gen_new))
    Set_Led(widget,LAB_GENPICIND,0xf00);
  else
    Set_Led(widget,LAB_GENPICIND,0x000);

  if (!strcmp(name,LAB_FILMFRMMAX))
  {
    globinfo.pr.lvg_movie_size_max_hr=GTK_ADJUSTMENT(widget)->value;
//    prefer.movie_max_nrframes=GTK_ADJUSTMENT(widget)->value;
  }
  if (!strcmp(name,LAB_FILMRESTART))
  {
    globinfo.pr.lvg_movie_start_utc_hr=GTK_ADJUSTMENT(widget)->value;
  }
  if (!strcmp(name,LAB_FILMLASTFRMRPT))
  {
    globinfo.pr.lvg_movie_rpt_lastfrm=GTK_ADJUSTMENT(widget)->value;
  }

  update_newsat_selected(NULL,widget);

}

static void do_recordbut(GtkWidget *widget,gpointer data)
{
  GtkWidget *wnd=Find_Parent_Window(widget);
  char *name=(char *)data;


  if (!strcmp(name,LAB_NOTIFY))
  {
    globinfo.pr.msg_notify=Get_Button(widget,LAB_NOTIFY);
  }


  if (!strcmp(name,LAB_REMOVECHAN))
  {
    GtkWidget *choosepart=Find_Widget(widget,PART_REMOVEITEMS);
    if (Get_Button(wnd,LAB_REMOVECHAN))
    {
      Set_Widgetcolor(choosepart,'b',0,0,0xff);
      Set_Led(widget,LAB_DELITEMS,0xf00);
      Sense_Button(choosepart,PART_REMOVEITEMS,TRUE);
    }
    else
    {
      Set_Widgetcolor(choosepart,'b',0,0,0);
      Set_Led(widget,LAB_DELITEMS,0x000);
      Sense_Button(choosepart,PART_REMOVEITEMS,FALSE);
    }
    globinfo.satlist->enable_remove=Get_Button(widget,LAB_REMOVECHAN);
    globinfo.rm_raw=globinfo.satlist->enable_remove;

  }
}

static GtkWidget *common_buts()
{
  GtkWidget *w[9];
/* ----- update ----- */
  w[1]=Create_Button(LAB_UPDATE,do_recordbut_common);
  w[2]=Create_Toggle(LAB_CRLOAD,do_recordbut_common,prefer.pr.record_at_start);
  w[3]=Create_Entry(LAB_NUPDATE,NULL,"%7s","");

  w[4]=Create_Led(LAB_DELOLDIND,0);
  w[5]=Create_Led(LAB_DELITEMS,0);
  w[4]=Pack("Delete",'h',w[4],5,w[5],5,NULL);

  w[6]=Create_Led(LAB_GENPICIND,0);
  w[7]=Create_Led(LAB_GENMOVIND,0);
  w[6]=Pack("Generate",'h',w[6],5,w[7],5,NULL);

  w[7]=Create_Button(LAB_SAVE,do_recordbut_common);

  w[0]=SPack("Updating","h",w[1],"2",w[2],"2",w[3],"2",w[4],"2",w[6],"3",w[7],"1",NULL);

  //default toggle doesn't do a 'do_recordbut_common'!
//  Set_Button(w[0],LAB_CRLOAD,prefer.pr.record_at_start);
  Set_Widgetcolor(w[0],'b',0x00,0,0);
  return w[0];
}

/*****************************************************
 * Live buttons
 *****************************************************/
char **create_str_satlist(int *nr,SAT_ORBITTYPE type)
{
  static char *s[20];
  SATLIST *sl;
  *nr=0;
  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    if (sl->type!=type) continue;
    if (*nr>=20) break;
    s[*nr]=sl->name;
    (*nr)++;
  }
  return s;  
}

GtkWidget *buttons_overlay(char *id,OVERLAYS ol,void func())
{
  GtkWidget *w;
  w=Create_ButtonArray(id,func,1,
              CHECKI,LAB_SHOWOL ,ol.add_overlay,
              CHECKI,LAB_SHOWLL ,ol.add_lonlat,
              CHECKI,LAB_SHOWMRK,ol.add_marks,
              CHECKI,LAB_SHOWCIT,ol.add_cities,
              CHECKI,LAB_SHOWTIM,ol.annotxt[0].enable,
              CHECKI,LAB_SHOWTXT1,ol.annotxt[1].enable,
              CHECKI,LAB_SHOWTXT2,ol.annotxt[2].enable,
              0);
  return w;
}

GtkWidget *buttons_clr(char *id,COLOUR clr,void func())
{
  GtkWidget *w;
  w=Create_ButtonArray(id,func,1,
              CHECKI,LAB_SHOWCLR,clr.compose,
              CHECKI,LAB_FIREDET,globinfo.pr.lvg_fire_detect,
              CHECKI,LAB_SHOWHRVLUM,clr.hrv_lum,
              SPIN,LAB_SHOWGAM,"%.1f%.1f%.1f",globinfo.pr.lvg_gamma,0.1,3.,
              0);
  return w;
}

#define NWELAYOUT
static GtkWidget *snb_choose_live()
{
  GtkWidget *w[10],*wb;
  SATLIST *sl;
  int h=0,v=0;
  globinfo.spm_live.bitshift=1;    // init value (actually bitshift!)
  if (!globinfo.pr.lvg_gamma) globinfo.pr.lvg_gamma=1.;
  
/* ----- Show live ----- */
  w[6]=NULL;
  w[5]=NULL;
  w[1]=Create_Check(LAB_SHOWNEW,do_recordbut_live,globinfo.pr.lvs_enable);
  w[2]=buttons_overlay("Overlays",globinfo.pr.lv_ol,do_recordbut_live);
  w[3]=buttons_clr("Clr",globinfo.pr.lv_clr,do_recordbut_live);
//  w[1]=Pack(NULL,'v',w[1],2,w[2],2,w[3],2,w[4],2,w[5],2,w[6],2,NULL);
  w[1]=Pack(NULL,'v',w[1],2,w[2],2,w[3],2,w[6],2,NULL);
  w[5]=Create_Radio("!unk",TRUE,NULL);
  w[3]=gtk_table_new(4,1,FALSE);
  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    char *name;
    if (!sl->use_in_showlist) continue;
#ifdef ADD_HEADER
    if (sl->header)
    {
      h=0; v++;
      w[4]=Create_Label(sl->header);
      gtk_table_attach(GTK_TABLE(w[3]),w[4],h,h+1,v,v+1,GTK_FILL,GTK_FILL,1,1);
      h=0; v++;
    }
#endif
    if ((sl->prev) && (strcmpd(sl->prev->grp_name,sl->grp_name)))
    {
      h=0; v++;
    }
    else if (sl->prev)
    {
      h++;
    }
    if (sl->show_name) name=sl->show_name; else name=sl->name;

    w[4]=Create_Radio(name,FALSE,do_recordbut_chansel);
    gtk_table_attach(GTK_TABLE(w[3]),w[4],h,h+1,v,v+1,GTK_FILL,GTK_FILL,1,1);
  }
  w[3]=Pack(LAB_SHOWSAT,'v',w[3],0,w[5],0,NULL);
  w[4]=Create_Optionmenu(LAB_SHOWCHAN,do_recordbut_live,0,0);
  w[5]=Create_Entry(LAB_SHOWCHAN2,do_recordbut_live,"%-6s",globinfo.pr.lv_chan);
  w[5]=Pack(NULL,'h',w[4],2,w[5],2,NULL);
  w[6]=Create_Button(LAB_MAPCLR,do_recordbut_live);
  w[3]=Pack("",'v',w[3],2,w[5],2,w[6],2,NULL);
  wb=Pack("Show 'Live'",'h',w[1],0,w[3],0,NULL);
  Sense_Button(wb,LAB_MAPCLR,FALSE);
  Set_Widgetcolor(wb,'b',0x00,0,0);
  gtk_object_set_data(GTK_OBJECT(wb),WDGT_ID,(gpointer)SHOWLIVE);
  do_recordbut_live(wb,LAB_SHOWNEW); // force sens of some buttons in right state
  return wb;
}


static void do_recordbut_gen2(GtkWidget *widget,gpointer data)
{
  char *name=(char *)data;
  if (!strcmp(name,LAB_MOVIEUSE))
  {
    if (Update_Togglelabel(widget))
    {
      Sense_Button(widget,LAB_MOVIEOPT,TRUE);
      globinfo.pr.lvg_moviecmd_constr=TRUE;
    }
    else
    {
      Sense_Button(widget,LAB_MOVIEOPT,FALSE);
      strcpy(globinfo.rerun_cmd,prefer.rerun_cmd);
      globinfo.pr.lvg_moviecmd_constr=FALSE;
    }
  }
  if (!strcmp(name,LAB_SPEED))
  {
    globinfo.pr.lvg_movie_speed=(int)Get_Adjust(widget,LAB_SPEED);

  }
  if (!strcmp(name,LAB_FULLSCR))
  {
    globinfo.pr.lvg_movie_fullscreen=Get_Button(widget,LAB_FULLSCR);
  }
  if (Get_Button(widget,LAB_MOVIEUSE))
  {
    SATLIST *sl;
    sl=Get_Satlist_Item(globinfo.satlist,SATLIST_NAME,globinfo.pr.lv_sat);
    create_contmoviecommand(sl);
  }
  Set_Entry(widget,LAB_SHOW_RERUNCMD,"%s",globinfo.rerun_cmd);

}


static GtkWidget *snb_generate_buts()
{
  GtkWidget *w[6],*wb,*wc,*wd,*we;
/* ----- Info ----- */
  w[1]=Create_Label("Record info");
  w[2]=Create_Entry(LAB_RECINFO,NULL,"   ");
  wb=SPack("","h",w[1],"1",w[2],"ef1",NULL);

/* ----- Generate live ----- */
  w[1]=Create_Check(LAB_LGEN,do_recordbut_gen,FALSE);

  w[2]=Create_ButtonArray(NULL,do_recordbut_gen,-3,
                         RADIOs,LAB_GENFILE,
                         RADIOn,LAB_GENMOV,
                         0);
  w[3]=Create_ButtonArray(BOX_MOVIE,do_recordbut_gen,2,
                         CHECKI,LAB_RMJPEG,TRUE,
                         LABEL,LAB_RMJPEG+1,
                         SPIN,LAB_FILMFRMMAX,"%3d%3d%3d%3d",4,globinfo.pr.lvg_movie_size_max_hr,0,672,  // prefer.movie_max_nrframes
                         LABEL,LAB_FILMFRMMAX+1,
                         SPIN,LAB_FILMRESTART,"%3d%3d%3d%",globinfo.pr.lvg_movie_start_utc_hr,-1,23,
                         LABEL,LAB_FILMRESTART+1,
                         SPIN,LAB_FILMLASTFRMRPT,"%3d%3d%3d",globinfo.pr.lvg_movie_rpt_lastfrm,0,100,
                         LABEL,LAB_FILMLASTFRMRPT+1,
                         0);

  w[4]=Create_ButtonArray("",do_recordbut_gen,-3,
                         CHECK,LAB_ESSENTIAL,
                         CHECK,LAB_RUNCMD1,
                         0);

  w[2]=Pack("Generate files",'h',w[2],1,w[3],1,w[4],1,NULL);

  Set_Widgetcolor(w[2],'b',0x00,0,0);
  wc=Pack("",'h',w[1],1,w[2],1,NULL);
  Set_Widgetcolor(wc,'b',0x00,0,0);
  Set_Widgetcolor(wc,'b',0x00,0,0);
 #if __GTK_WIN32__ == 0
  {
    char *p;
    if ((p=strchr(prefer.prog_playmovie,'%'))) *p=0;
  }
  w[1]=Create_Check(LAB_RUNCMD2,do_recordbut_gen,FALSE);
  w[2]=Create_Toggle(LAB_MOVIEUSE,do_recordbut_gen2,FALSE);

  w[3]=Create_ButtonArray(LAB_MOVIEOPT,do_recordbut_gen2,4,
                          LABEL,"Movie prog.",
                          ENTRY_NOFUNC,"!Movie program",prefer.prog_playmovie,
                          LABEL,LAB_SPEED+1,
                          SPIN,LAB_SPEED,"%3d%3d%3d",globinfo.pr.lvg_movie_speed,1,300,
                          LABEL,LAB_FULLSCR+1,
                          CHECKI,LAB_FULLSCR,globinfo.pr.lvg_movie_fullscreen,
                           0);
//  w[4]=Create_Label("For colour mapping\nsee main tab");
  w[2]=Pack(NULL,'h',w[2],1,w[3],1,NULL);
  we=Pack("",'h',w[1],1,w[2],1,NULL);
  w[1]=Create_Entry(LAB_SHOW_RERUNCMD,NULL,"%40s",globinfo.rerun_cmd);
  we=Pack("Movie program settings",'v',we,1,w[1],1,NULL);
  Set_Widgetcolor(we,'b',0x00,0,0);
 #else
   we=Pack(NULL,'v',NULL);
 #endif

//  Sense_Button(we,LAB_MOVIEOPT,FALSE);
  wd=SPack(LAB_RECEIVE,"v",wc,"5",we,"5",wb,"E5",NULL);
  Set_Widgetcolor(wd,'b',0x0,0,0);
  gtk_object_set_data(GTK_OBJECT(wd),WDGT_ID,(gpointer)AFTERREC_SET);


// see also pref_to_gui!
  Set_Button(wd,LAB_MOVIEUSE,globinfo.pr.lvg_moviecmd_constr);
  Set_Button(wd,LAB_LGEN,globinfo.pr.lvg_enable);
  Set_Button(wd,LAB_GENMOV,FALSE);
  Set_Button(wd,LAB_GENMOV,globinfo.pr.lvg_pic0_movie1);
  Sense_Button(wd,BOX_MOVIE,globinfo.pr.lvg_pic0_movie1);
//  Sense_Button(wd,LAB_RMJPEG,globinfo.pr.lvg_pic0_movie1);
//  Set_Button(wd,LAB_RMJPEG,globinfo.pr.lvg_pic0_movie1);
  Set_Button(wd,LAB_SHOWTIM,globinfo.pr.lv_ol.annotxt[0].enable);
  Set_Button(wd,LAB_ESSENTIAL,globinfo.pr.lvg_essential_only);
  Set_Button(wd,LAB_RUNCMD1,globinfo.pr.lvg_run_script);
//  Set_Button(wd,LAB_RUNCMD2,globinfo.pr.lvg_rerun_script);

  return wd;
}

/*****************************************************
 * 'Remove data' buttons
 *****************************************************/
#define LAB_MSGALL "  All  "
static void choose_chanfunc(GtkWidget *widget,gboolean data)
{
  char *name=(char *)data;
  SATLIST *sl,*cl;
  if (!strcmp(name,LAB_MSGALL))
  {
    for (sl=globinfo.satlist; sl; sl=sl->next)
    {
      if (is_msg(sl->name))
      {
        gboolean ss=FALSE;
        for (cl=sl->chans; cl; cl=cl->next)
        {
          if (!Get_Button(widget,cl->name)) ss=TRUE;
        }
        for (cl=sl->chans; cl; cl=cl->next)
        {
          Set_Button(widget,cl->name,ss);
        }
        break;
      }
    }
  }

  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    if (!strcmp(name,sl->name))
    {
      sl->remove=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
    }
    for (cl=sl->chans; cl; cl=cl->next)
    {
      if (!strcmp(name,cl->name))
      {
        cl->remove=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
      }
    }
  }
  if (!strcmp(name,LAB_UNKNOWN))
    globinfo.satlist->unk_sel=Get_Button(widget,name);
}

static GtkWidget *snb_aging()
{
  GtkWidget *w[5];
/* delete old */
  w[1]=Create_Toggle(LAB_CDELOLD,do_recordbut_gen,FALSE);  
  w[3]=Create_Entry(LAB_CDDELRUNNEXT,NULL,"%20s","");
  w[2]=Create_Entry(LAB_DELTIME,NULL,"%d days, %d hours",
                    prefer.deldaymin[0],(prefer.roundday? 0 : prefer.deldaymin[1]));
  w[4]=Create_Label("See\nPreferences.");
  w[0]=Pack(NULL,'v',w[1],1,w[2],1,w[3],1,NULL);
  w[0]=Pack("Aging",'h',w[0],1,w[4],1,NULL);
  Set_Widgetcolor(w[0],'b',0x00,0,0);
  w[0]=Pack(NULL,'v',w[0],1,NULL);

  return w[0];
}

static GtkWidget *snb_choose_removedata()
{
  GtkWidget *w[10];
  int h,v;
  SATLIST *sl,*cl;

/* Meteosat new generation satellites */
  v=0; h=0;
  w[0]=gtk_table_new(3,1,FALSE);

/* ----- Remove live ----- */
  w[1]=Create_Check(LAB_REMOVECHAN,do_recordbut,FALSE);
  w[8]=Pack("Raw data:",'v',w[1],1,NULL);
//  Set_Widgetcolor(w[2],'b',0x00,0,0);

  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    if (!sl->use_in_deletelist) continue;
    if (!is_msg(sl->name)) continue;
    if (strchr(sl->name,'*')) continue;
    if (strstr(sl->name,"RSS")) continue;
    w[1]=Create_Check(sl->name,choose_chanfunc,sl->remove);
    gtk_table_attach(GTK_TABLE(w[0]),w[1],h,h+1,v,v+1,
                         GTK_FILL,GTK_FILL,1,1);
    h++;
    if (h>=6) { h=0; v++; }
  }

/* Meteosat old satellites */
  v=0; h=0;
  w[2]=gtk_table_new(3,1,FALSE);
  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    if (!sl->use_in_deletelist) continue;
    if (!is_mfg(sl->name)) continue;
    w[3]=Create_Check(sl->name,choose_chanfunc,sl->remove);
    gtk_table_attach(GTK_TABLE(w[2]),w[3],h,h+1,v,v+1,
                         GTK_FILL,GTK_FILL,1,1);
    h++;
    if (h>=6) { h=0; v++; }
  }

/* Other satellites/sources */
  v=0; h=0;
  w[4]=gtk_table_new(3,1,FALSE);
  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    if (!sl->use_in_deletelist) continue;
    if (is_msg(sl->name)) continue;
    if (is_mfg(sl->name)) continue;

    w[5]=Create_Check(sl->name,choose_chanfunc,sl->remove);
    gtk_table_attach(GTK_TABLE(w[4]),w[5],h,h+1,v,v+1,
                         GTK_FILL,GTK_FILL,1,1);
    h++;
    if (h>=4) { h=0; v++; }
  }
  w[5]=Create_Check(LAB_UNKNOWN,choose_chanfunc,globinfo.satlist->unk_sel);
  gtk_table_attach(GTK_TABLE(w[4]),w[5],h,h+1,v,v+1,
                         GTK_FILL,GTK_FILL,1,1);
/* MSG channels */
  v=0; h=0;
  w[6]=gtk_table_new(3,1,FALSE);
  for (sl=globinfo.satlist; sl; sl=sl->next)
  {
    if (is_msg(sl->name))
    {
      for (cl=sl->chans; cl; cl=cl->next)
      {
        w[7]=Create_Check(cl->name,choose_chanfunc,cl->remove);
        gtk_table_attach(GTK_TABLE(w[6]),w[7],h,h+1,v,v+1,
                             GTK_FILL,GTK_FILL,1,1);
        h++;
        if (h>=6) { h=0; v++; }
      }
      h=6; v=0;
      w[7]=Create_Button(LAB_MSGALL,choose_chanfunc);
      gtk_table_attach(GTK_TABLE(w[6]),w[7],h,h+1,v,v+1,
                             GTK_FILL,GTK_FILL,1,1);
      h++;
      if (h>=6) { h=0; v++; }
      break;
    }
  }

/************************************************************************/  
  w[0]=Pack("Satellites MSG ",'h',w[0],1,NULL);           /* MSG list */
  w[6]=Pack("Channels",'h',w[6],1,NULL);                 /* channel list */
  w[0]=Pack("Meteosat New Generation",'v',w[0],1,w[6],1,NULL);
  Set_Widgetcolor(w[0],'b',0,0,0);

  w[2]=Pack("Satellites MFG ",'h',w[2],1,NULL);           /* MET list */
  Set_Widgetcolor(w[2],'b',0,0,0);

  w[4]=Pack("Other sources ",'h',w[4],1,NULL);    /* other list */
  Set_Widgetcolor(w[4],'b',0,0,0);
  w[9]=Create_Label("Immediately delete next data just received ");

//  w[9]=Pack(NULL,'v',w[9],1,w[8],1,NULL);
  w[9]=Pack(NULL,'h',w[8],1,w[9],1,NULL);

  w[0]=Pack(PART_REMOVEITEMS,'v',w[0],1,w[2],1,w[4],1,NULL);
  Set_Widgetcolor(w[0],'b',0x00,0,0x00);
  gtk_object_set_data(GTK_OBJECT(w[0]),WDGT_ID,(gpointer)PART_REMOVEITEMS);

  w[0]=Pack("Del before process",'v',w[9],3,w[0],1,NULL);
  Set_Widgetcolor(w[0],'b',0,0,0x00);
  gtk_object_set_data(GTK_OBJECT(w[0]),WDGT_ID,(gpointer)AFTERREC_DEL);

  w[0]=Pack(NULL,'v',w[0],1,NULL);   // Needed for gtk_widget_set_sensitive...
  gtk_widget_show_all(w[0]);

  Set_Button(w[0],LAB_REMOVECHAN,FALSE); // to set delete-items to 'not selectable'

  return w[0];
}

static GtkWidget *snb_other_recbuts()
{
  GtkWidget *wa;
  wa=Create_Check(LAB_NOTIFY,do_recordbut,globinfo.pr.msg_notify); // MSG notify; run if epi is received
  wa=Pack(NULL,'h',wa,1,NULL);
  wa=Pack("Run program after last of MSG data is received",'h',wa,1,NULL);
  Set_Widgetcolor(wa,'b',0x00,0,0);
  wa=Pack(NULL,'h',wa,1,NULL);
  wa=Pack(NULL,'v',wa,1,NULL);
  return wa;
}


GtkWidget *nb_record()
{
  GtkWidget *wa,*wb,*wc,*wd,*we,*wf,*wz;
  wa=common_buts();
  wb=snb_choose_live();
  wc=snb_generate_buts();
  wd=snb_aging();
  we=snb_choose_removedata();
  wf=snb_other_recbuts();

  wz=Create_Notebook(NULL,GTK_POS_TOP,
                     "Show live"       ,wb,
                     "Generate"        ,wc,
                     "Aging"           ,wd,
                     "Items to delete" ,we,
                     "Other"           ,wf,
                     NULL);


  wz=Pack(RECORD_TAB,'v',wa,1,wz,1,NULL);
  gtk_widget_show_all(wz);

  return wz;
}
