/*--------------------------------------------------------------------------------
 *
 *  File          :  parse_xml.h
 *  Related Files :  
 *
 *  Author(s)     :  R. Alblas
 *
 *  Contents      :  header file for parse-xml 
 *
 *--------------------------------------------------------------------------------*/
#ifndef PARSE_XML
#define PARSE_XML

#define LENTAG 500
#define LENSTR 500              // expected max. length of string between xml-tags

typedef struct xmltag
{
  struct xmltag *prev,*next;
  struct xmltag *lower;
  struct xmltag *upper;
  char name[LENTAG];
  char extname[LENTAG];
  char str[LENSTR];
  char *filename;
} XML;

#define forall_tags(x,x1) for (x1=x; x1; x1=x1->next)
#define forall_named_tags(x,x1,name) for (x1=x; (x1=find_tag(x1,name)); x1=x1->next)
#define forall_named_tags_cur(x,x1,nm) for (x1=x; x1; x1=x1->next) if (!strcmp(x1->name,nm))

XML *parse_xml(FILE *);
XML *find_tag(XML *,char *);
XML *find_tag_cur(XML *,char *);
void pri_xml(XML *);
void Remove_XMLTags(XML *);
#endif
