/*******************************************************************
 * Copyright (C) 2003 R. Alblas 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 * Content:
 *   PIC_CHARS pic_info(GROUP *grp,GtkWidget *wdgt,GENMODES *modes)
 ********************************************************************/
#include "xrit2pic.h"
#include "xrit2pic_defines.h"
#include <string.h>
#define DELTA_PIXn

extern GLOBINFO globinfo;
extern PREFER prefer;

/*******************************************************************
 * Prepair generation.
 ********************************************************************/


static void replace_spaces(char *l)
{
  for (; *l; l++) if (*l==' ') *l='_';
}

/*
%k		grp->h_or_l
%s		grp->sat_src
%R		grp->xh.region
%c		pc.chan
%t		timestr
%n		channelnumber
%y/%M/%d/%h/%m	tijd
%r		pc.first_chunck
Example:
"%p%S_%c_%t%r"
*/

static void mk_filename(GROUP *grp,CHANNEL *chan,char *frmt)
{
  PIC_CHARS pc=grp->pc;
  char str[200];
  char timestr[200];
  /* Gen timestring for filename generation */
  *timestr=0;
  strftime(timestr,20,"%y%m%d_%H%M",&grp->grp_tm);

  if (frmt)
  {
    strcpy(pc.fno,frmt);

    sprintf(str,"%c",grp->h_or_l);
    replace_str(pc.fno,"%k",str);

    replace_str(pc.fno,"%s",grp->sat_src);
    replace_str(pc.fno,"%c",pc.chan);
    replace_str(pc.fno,"%t",timestr);
    replace_str(pc.fno,"%R",grp->region);

    if ((!grp->selected) || (!grp->pc.is_color))
    {
      sprintf(str,"%02d",chan->chan_nr);
      replace_str(pc.fno,"%n",str);
      replace_str(pc.fno,"%C","");
    }
    else
    {
      replace_str(pc.fno,"%n"," ");
      replace_str(pc.fno,"%C",globinfo.pixmap.clrmapspec.name_sh);
    }
    
    if ((!grp->selected) && (!chan->selected))
    {
      sprintf(str,"%dto%d",pc.first_chunck,pc.last_chunck);
      replace_str(pc.fno,"%r",str);
    }
    else
    {
      replace_str(pc.fno,"%r","");
    }
    strftime(timestr,200,pc.fno,&grp->grp_tm);
    strcpy(pc.fno,timestr);
  }
  else
  {
    strcpy(pc.fno,pc.picname);
  }
  replace_spaces(pc.fno);
  grp->pc=pc;
}

static void mk_picname(GROUP *grp,CHANNEL *chan1)
{
  PIC_CHARS pc=grp->pc;
  char timestr[100];
  /* Gen timestring for filename generation */
  *timestr=0;
  strftime(timestr,20,"%y%m%d_%H%M",&grp->grp_tm);

/* Determine picname */
  if (((grp->selected) || ((chan1) && (chan1->selected))) && (globinfo.segmrange[0]==0))           /* full picture */
  {
    if (*pc.chan)
      sprintf(pc.picname,"%c%s_%s_%s",grp->h_or_l,grp->sat_src,pc.chan,timestr);
    else
      sprintf(pc.picname,"%c%s_%s",grp->h_or_l,grp->sat_src,timestr);
  }
  else if ((grp->pro_epi) &&
       (((grp->pro_epi->pro) && (grp->pro_epi->pro->selected)) ||
        ((grp->pro_epi->epi) && (grp->pro_epi->epi->selected)))) /* pro/epi */
  {
    sprintf(pc.picname,"%c%s%s_%s",grp->h_or_l,grp->sat_src,pc.chan,timestr);
  }
  else if (pc.first_chunck==pc.last_chunck)
  {
    sprintf(pc.picname,"%c%s_%s_s%d_%s",
                   grp->h_or_l,grp->sat_src,pc.chan,pc.first_chunck,timestr);
  }
  else                                                /* partial picture */
  {
    sprintf(pc.picname,"%c%s_%s_s%dto%d_%s",
                   grp->h_or_l,grp->sat_src,pc.chan,pc.first_chunck,pc.last_chunck,timestr);
  }
  switch(pc.gmap)
  {
    case plate_carree: strcat(pc.picname,"_pc"); break;
    case mercator    : strcat(pc.picname,"_mc"); break;
    case polar_n     : strcat(pc.picname,"_pn"); break;
    case polar_cn    : strcat(pc.picname,"_pn"); break;
    case polar_s     : strcat(pc.picname,"_ps"); break;
    case polar_cs    : strcat(pc.picname,"_ps"); break;
    case normal      :                           break;
  }

  grp->pc=pc;
}

//#define SWAP(a,b) a=a^b; b=a^b; a=a^b   // werkt niet goed hier!??

static CHANNEL *get_nonhrv(GROUP *grp)
{
  CHANNEL *chan1;
  for (chan1=grp->chan; chan1; chan1=chan1->next)
  {
    if ((chan1->chan_name) && ((strcmp(chan1->chan_name,"HRV")))) break;
  }
  return chan1;
}

static void load_posinfo(CHANNEL *chan,PIC_CHARS *pc)
{
  int loff_start;
  SEGMENT *segm;
  if (!chan) return;
  if (!(segm=chan->segm)) return;

  if (!segm->xh.loff)
    update_segment_xrithdr(segm);

  // make one start loff, to determine locations for all related segments
  //      segm    seqstrt seqend  nl      loff
  // MSG  1       1       8       464      1856 =  ( 8/2 + (1- 1))*nl
  // MSG  8       1       8       464     -1392 =  ( 8/2 + (1- 8))*nl
  // RSS  6       6       8       464     - 464 =  ( 8/2 + (1- 6))*nl
  // RSS  8       6       8       464     -1392 =  ( 8/2 + (1- 8))*nl
  // HIM  1       1       10      550      2750 -> (10/2 + (1- 1))*nl=2750
  // HIM  10      1       10      550      2750 -> (10/2 + (1-10))*nl=-2200
  // loff_start normally 0, except if first segment(s) are missing

  // nr. first existing segment = "planned"=seq_start (from header)
  // normaly chan1->segm->xh.segment =  first segment to use
  // loff_start normally 0, except if first segment(s) are missing
  if (segm->xh.xrit_frmt==JMA)         // himawari: loff=2750 voor alle segmenten
  {
    if (pc->force_allsegm)
      loff_start=0;
    else
      loff_start=(1-segm->xh.segment)*segm->xh.nl;
  }
  else                                        // MSG: lof=segm. afh.: 1856,1392,...-1392
    loff_start=(segm->xh.segment-chan->seq_start)*segm->xh.nl;

  pc->gchar.coff         =segm->xh.coff;
  pc->gchar.cfac         =segm->xh.cfac;
  pc->gchar.loff         =segm->xh.loff + loff_start;
  pc->gchar.lfac         =segm->xh.lfac;
  pc->gchar.subsat_lon   =segm->xh.subsat_lon;
}

static SEGMENT *segm_selected(CHANNEL *chan)
{
  SEGMENT *segm;
  for (segm=chan->segm; segm; segm=segm->next) if (segm->selected) break;
  return segm;
}

static gboolean chan_or_segm_selected(CHANNEL *chan)
{
  if (!chan) return FALSE;
  if (chan->selected) return TRUE;
  if (segm_selected(chan)) return TRUE;
  return FALSE;
}


// If area not full globe: for the moment ensure ALL segments are present!
#define DETECT_LIM_SEGM 0
/***********************************************
 * Determine some picture characteristics
 ***********************************************/
PIC_CHARS pic_info(GROUP *grp,GtkWidget *wdgt,GENMODES *modes)
{
  CHANNEL *chan,*chan1=NULL;
  SEGMENT *segm;
  gboolean chan1_maybe_not_used=FALSE;
  PIC_CHARS pc=grp->pc;
  /* Clear picinfo struct except...*/
  if (modes) pc.gmap=modes->gmap;         // take over geomapping (waarom niet al in grp->pc?)
// volgende opent alle files van grp en kan daarom lang duren!
// Zat er in 2016 nog niet in.
// (Zie ook popup_wnd.c, piclistfunc, mklijst regel 266 (na else))
// dit haalt dus van alle files (alle segmenten) hdr-info binnen. 
// waarom nodig? voor film met HRV? (zie popup_wnd.c)
//  update_group_xrithdr(grp);

  chan1=get_nonhrv(grp);                  // get first non-hrv channel (selected or not)
  if (!chan1)
  {
    chan1=grp->chan;            // no non-hrv channel: get first channel anyway (will be HRV) */
  }
  if ((chan1) && (!chan_or_segm_selected(chan1))) chan1_maybe_not_used=TRUE; // the first found channel is not selected

  // If not composed and chan1 (or segm of chan1) not selected:
  //    case: file-tree still building up (busy with receiving, auto-translate)
  //    find first chan which is selected. */
  if ((!grp->compose) && (chan1) && (!chan_or_segm_selected(chan1)))
  {
    for (chan1=grp->chan; ((chan1) && (!chan1->selected)); chan1=chan1->next);
    if (!chan1)                          // nothing selected:
    {
      chan1=get_nonhrv(grp);             //  get first non-hrv cghannel
//      if (!chan1) chan1=grp->chan;       // or get (waarom al dit?) -> niet doen, want HRV kan als eerste in groep zitten
                                           //                            gaat mis bij autotranslate, waarbij eerst HRV-kanalen binnenkomen.                 
      if (chan1) chan1_maybe_not_used=TRUE;
    }
  }
  if (!chan1) chan1=grp->pro_epi;  /* if not: asume pro/epi file to get */
  if (!chan1) return pc;           /* if not: error, return */

/* Determine mapping */
  if (grp->compose)
  {
    pc.is_color=TRUE;
    /* Get custom mapping. If no clrmap-window opened: Load default mapping. 
       chan->r,g,b will get multiplication factors for each channel.
    */
    if ((!modes) || (!modes->wnd_clrmap))
    {
      if ((modes) && (modes->for_live))
        get_map(wdgt,grp->chan,LAB_COLOR,NULL,&globinfo.pixmap_gen);
      else
        get_map(wdgt,grp->chan,LAB_COLOR,NULL,&globinfo.pixmap);
    }
    else
    {
      if (modes->for_live)
        get_map(wdgt,grp->chan,modes->wnd_clrmap,NULL,&globinfo.pixmap_gen);
      else
        get_map(wdgt,grp->chan,modes->wnd_clrmap,NULL,&globinfo.pixmap);
    }
  }
  else if ((globinfo.spm.map_temp) || (globinfo.spm.map_temp_G_mA))
  {
    pc.is_color=TRUE;
    pc.map_temp=globinfo.spm.map_temp;
    pc.map_temp_G_mA=globinfo.spm.map_temp_G_mA;
    chan1->r=chan1->g=chan1->b=1.;
  }
  else
  {
    chan1->r=chan1->g=chan1->b=1.;
  } 

/* Determine characteristics of (composed) pic */
  pc.widthmax=0;
  pc.heightmax=0;
  for (chan=grp->chan; chan; chan=chan->next)
  {
    if (!chan->chan_name) continue;
    if ((!strcmp(chan->chan_name,"HRV"))) if (modes) chan->lum=modes->use_hrv_lum;      // globinfo.hrv_lum;
    if ((!chan->r) && (!chan->g) && (!chan->b) && (!chan->lum)) continue; // not visible
   chan->max_x_shift=0;
    if ((!strcmp(chan->chan_name,"HRV"))) // && (chan->selected))
    {
      chan->width_totalglobe=11136;
      if ((chan->segm) && (chan->segm->xh.xrit_frmt==STDFRMT))
      {
  // upper_x_shift and lower_x_shift: Means 'shift to east'.
  //   Org. file: upside-down, so shift = 'shift pic to higher x-value and increase width'.
  //   stdfrmt from MDM: Not upside-down, so shift = increase width, leave pic at left (i.e., shift east). 
  //    For stdfrmt (comon
  //           suf.    width    position       range of total (from east)
  //           A       5568	left=0            0 ... 5568
  //           E       5568	2112=0         2112 ... 7680      
  //           G       5568	center=0       2784 ... 8352
  //           W       7680	right=90          0 ... 7680
  //           F       11136	center=0          0 ... 11136
  //
  //           N=top 3248 lines only (7 segments)

        chan->upper_x_shift=0;
        if (strchr(chan->segm->xh.mdm_pos_code,'g'))
        {
          chan->upper_x_shift=2784;
        }
        if (strchr(chan->segm->xh.mdm_pos_code,'e'))
        {
          chan->upper_x_shift=2112;
        }
        if (strchr(chan->segm->xh.mdm_pos_code,'n'))
        {
          chan->height_totalglobe=11136;
        }
        chan->lower_x_shift=0;       // upper_x_shift !=0 makes pic wider, result: shift pic to east
        chan->shift_ypos=11136;      // giving space right of pic (north-to-south!)
        chan->max_x_shift=MAX(chan->upper_x_shift,chan->lower_x_shift);
      }
      else // not from std-format, so take into account lower/upper shifts
      {
        if ((grp->pro_epi) && (grp->pro_epi->pro))  /* contains shift-info HRV */
        {
          chan->lower_x_shift=grp->pro_epi->pro->lower_east_col-1;
          chan->upper_x_shift=grp->pro_epi->pro->upper_east_col-1;
          chan->shift_ypos=grp->pro_epi->pro->lower_nord_row-1;
        }
        else                       /* no shift-info HRV available; take def. */
        {
          chan->lower_x_shift=0;
          chan->upper_x_shift=HRV_XSHIFT;    // never 100% correct...
          chan->shift_ypos=HRV_SHIFT_YPOS;   // same
        }
        // x_shift determines extra width because of HRV-shift
        chan->max_x_shift=MAX(chan->upper_x_shift,chan->lower_x_shift);
      }
    }
    /* Determine original height of tallest channel */ 
    pc.heightmax=MAX(pc.heightmax,chan->nl*(chan->seq_end-chan->seq_start+1));

    /* Determine original width of tallest channel; keep shift in HRV pic */ 
    pc.widthmax=MAX(pc.widthmax,chan->nc+chan->max_x_shift);

    if (prefer.full_globe)
      pc.widthmax=MAX(pc.widthmax,chan->width_totalglobe);
  }

  /* Determine first and last chunck to use for pic (if 1 channel is used) */
  if ((grp->selected) || (chan1->selected))         /* full picture */
  {
    int first_chunck,last_chunck;
    first_chunck=chan1->seq_start;
    last_chunck=chan1->seq_end;
/*
NIETDOEN: benodigde segmenten hangt af van 'area' en wat in prefs staat!
Dus dan maar alles compleet hoewel misschien niet nodig.
*/
    #if DETECT_LIM_SEGM != 0
    if ((modes) && (modes->area_nr) && (!IS_POLAR(grp)))
      first_chunck=last_chunck-chan1->seq_end/4+1;
    #endif

    if (!chan1_maybe_not_used)
    {
      if (chan_complete(chan1,first_chunck,last_chunck))
      {
        pc.incomplete=FALSE;
      }
      else
      {
        pc.incomplete=TRUE;
      }
      if ((chan1->chan_name) && (!strcmp(chan1->chan_name,"HRV")) && (chan1->group) && (!chan1->group->pro_epi))
      {
        pc.incomplete_pro=TRUE;
      }
      else
      {
        pc.incomplete_pro=FALSE;
      }
    }
    pc.first_chunck=first_chunck;
    pc.last_chunck=last_chunck;
  }
  else
  {
    for (segm=chan1->segm; segm; segm=segm->next)
    {
      if (!pc.first_chunck)
        pc.first_chunck=segm->xh.segment;
      else
        pc.first_chunck=MIN(pc.first_chunck,segm->xh.segment);

      if (!pc.last_chunck) 
        pc.last_chunck=segm->xh.segment;
      else
        pc.last_chunck=MAX(pc.last_chunck,segm->xh.segment);
    }
    if (pc.last_chunck-pc.first_chunck+1 != chan1->nr_segm)
    {
// Don't set 'incomplete'; limited # segms selected.
//      pc.incomplete=TRUE;
    }
  }

/* Next is only for first chan, so only really valid if just 1 chan is selected */
  pc.nrchuncks=(pc.last_chunck-pc.first_chunck)+1;  // # chnks selected

  if (chan1->seq_end-chan1->seq_start+1 != pc.nrchuncks) pc.partly=TRUE;
  
  pc.width=pc.widthmax; 
//  pc.height=chan1->nl*pc.nrchuncks;
  pc.height=pc.heightmax;
  pc.y_chunck=chan1->nl;
  pc.depth=chan1->nb;
  pc.image_iformat=chan1->ifrmt;
  pc.scan_dir=chan1->scan_dir;

/* Determine part of name for pic to generate: mapping */
  if (grp->compose)
  {
    char tmp[20];
    *tmp=0;
    *pc.chan=0;
    if ((globinfo.spm.compose_type!=map_vis_hmsg))
    {
      sprintf(pc.chan,"%s%s",pc.chan,globinfo.pixmap.clrmapspec.name_sh);
    }
    else
    {
      for (chan=grp->chan; chan; chan=chan->next)
      {
        if (chan->r) sprintf(tmp,"%s%x",tmp,chan->chan_nr);
        if (strlen(tmp) > 3) break;      // limit in case of idiot mapping
      }
      if (*tmp) sprintf(pc.chan,"%sR%s",pc.chan,tmp);

      *tmp=0;
      for (chan=grp->chan; chan; chan=chan->next)
      {
        if (chan->g) sprintf(tmp,"%s%x",tmp,chan->chan_nr);
        if (strlen(tmp) > 3) break;      // limit in case of idiot mapping
      }
      if (*tmp) sprintf(pc.chan,"%sG%s",pc.chan,tmp);

      *tmp=0;
      for (chan=grp->chan; chan; chan=chan->next)
      {
        if (chan->b) sprintf(tmp,"%s%x",tmp,chan->chan_nr);
        if (strlen(tmp) > 3) break;      // limit in case of idiot mapping
      }
      if (*tmp) sprintf(pc.chan,"%sB%s",pc.chan,tmp);
    }
    *tmp=0;
    for (chan=grp->chan; chan; chan=chan->next)
    {
      if (chan->lum) sprintf(tmp,"%s%x",tmp,chan->chan_nr);
      if (strlen(tmp) > 3) break;      // limit in case of idiot mapping
    }
    if (*tmp) sprintf(pc.chan,"%sH%s",pc.chan,tmp);
  }
  else if (grp->gen_rah)
  {
    strcpy(pc.chan,"");
  }
  else if (chan1->chan_name)
  {
    strcpy(pc.chan,chan1->chan_name);
  }
  strcpy(pc.sat_src,grp->sat_src);

  grp->pc=pc;
  mk_picname(grp,chan1);
  if ((modes) && (modes->ofile))
    mk_filename(grp,chan1,modes->ofile);
  else if (prefer.use_fn_frmt)
    mk_filename(grp,chan1,prefer.fn_frmt);
  else
    mk_filename(grp,chan1,NULL);

  grp->pc.bitshift=globinfo.bitshift;
  grp->pc.orbittype=grp->orbittype;

  if (grp->pc.orbittype==POLAR)
  {
    grp->pc.lines_per_sec=chan1->lines_per_sec;
    load_kepler(grp);
    grp->pc.lines_per_sec=chan1->lines_per_sec;
    if (grp->pc.gmap==normal)
      grp->pc.scan_dir=polar_dir(grp);
    else
      grp->pc.scan_dir='n';
  }
  pc=grp->pc;

  /* Determine col offset/line offset for lon/lat calc. from x/y */
  if (IS_GEO(grp))
  {
    CHANNEL *hrvchan=NULL;
    if (Chan_Contributes(grp,"HRV"))  // contains HRV
    {
      hrvchan=Get_Chan(grp->chan,"HRV");
    }
    if (hrvchan)                           // contains HRV
    {
      load_posinfo(hrvchan,&pc);
  // Correct coff. Mapping is always such that pic starts east with 90 degrees, so for hrv coff always 5566.
      if (hrvchan->segm->xh.nl*(hrvchan->segm->xh.segment-1) < hrvchan->shift_ypos)
        pc.gchar.coff+=hrvchan->lower_x_shift;
      else
        pc.gchar.coff+=hrvchan->upper_x_shift;
    }
    else // no HRV
    {
      CHANNEL *chan1;
      chan1=get_nonhrv(grp);
//      if (!chan1) chan1=grp->chan;
      if (chan1)                   // expected always !=0
      {
        load_posinfo(chan1,&pc);
      }
    }

    if (pc.gchar.cfac)
      pc.orbit.valid=TRUE;         // geo has not! always position info

#ifdef NIETNODIG_ZIE_load_posinfo
    if ((grp->pro_epi) && (grp->pro_epi->pro)) 
      if (grp->pro_epi->pro->ProjectionDescription.LongitudeOfSSP)
        pc.gchar.subsat_lon      =grp->pro_epi->pro->ProjectionDescription.LongitudeOfSSP;
#endif
  }  /* grp->orbittype==GEO */

  grp->pc=pc;

  /* Determine size of pic */
  if (modes)
  {
    if ((globinfo.area_nr>0) && (globinfo.area_nr<=NRGEODEFS))
    {
      modes->geoarea=prefer.geoarea[globinfo.area_nr-1];  // Boundaries channels
    }

    if ((IS_GEO(grp)) && (pc.gchar.cfac) &&               // coff/loff etc. available
       (modes->geoarea.delta.lon) && (modes->geoarea.delta.lat))  //   and dlon/dlat speccified
    { 
      geoarea2xy(grp,modes);
    }
    else
    {
      size_pic(grp,modes);
    }
  }
#ifdef LUTTEN
  create_rgbluts(grp,FALSE,grp->conv_temp,FALSE,globinfo.lut.use);
#endif
  grp->pc.done=TRUE;
  return grp->pc;
}

