/*******************************************************************
 * Copyright (C) 2003 R. Alblas 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 ********************************************************************/
#include "xrit2pic.h"
#include <string.h>

extern PREFER prefer;

static char *sattype(char *s)
{
  if (!strcmp(s,"MET5"))          return "MFG"; 
  if (!strcmp(s,"MET6"))          return "MFG"; 
  if (!strcmp(s,"MET7"))          return "MFG"; 
  if (!strncmp(s,"GOES",4))       return "GOES"; 
  if (!strncmp(s,"MTSAT",4))      return "GOES"; 
  if (!strncmp(s,"MSG",3))        return "MSG"; 
  if (!strcmp(s,"Srvc"))          return "Messages";
  if (!strncasecmp(s,"noaa",4))   return "NOAA"; 
  if (!strncasecmp(s,"METOP",5))  return "METOP";
  if (!strncmp(s,"DWDSAT",6))     return "DWDSAT";
  return "rest";
}

char *make_destdir(char *dest_dir,PIC_CHARS *pc)
{
  char *tfno=NULL;
  if (*dest_dir)
  {
    strcpyd(&tfno,dest_dir);
    if (RCHAR(tfno)!=DIR_SEPARATOR) sprintfd(&tfno,"%s%c",tfno,DIR_SEPARATOR);
    if (prefer.split_destdir) sprintfd(&tfno,"%s%s%c",tfno,sattype(pc->sat_src),DIR_SEPARATOR);
    if (!make_dir(tfno));
//      Create_Message("Info","Created new dir\n%s.",tfno);
  }
  return tfno;
}

char *make_filename(char *dest_dir,PIC_CHARS *pc,char *ext,GENMODES *modes,gboolean do_split)
{
  char *tfno=NULL;
  tfno=make_destdir(dest_dir,pc);

  // tiff: alleen dir, geen filenaam?
  if ((modes) && (modes->image_oformat==PIC_TIFF)) return tfno;

  strcatd(&tfno,pc->fno);
  if (modes->ofile) return tfno;

  if (ext)
  {
    strcatd(&tfno,ext);
  }
  else if (modes)
  {
    if (modes->image_oformat==PIC_RAH)
    {
      strcatd(&tfno,".rah");
    }
    else if ((modes->image_oformat==PIC_JPEG) || (modes->image_oformat==PIC_CJPEG))
    {
      strcatd(&tfno,".jpg");
    }
    else if (modes->image_oformat==PIC_PGM8)
    {
      strcatd(&tfno,".pgm");
    }
    else if (modes->image_oformat==PIC_PGM)
    {
      if (pc->is_color)
      {
        strcatd(&tfno,".ppm");
      }
      else
      {
        strcatd(&tfno,".pgm");
      }
    }
  }
  return tfno;
}

void make_destdir1(char *dest_dir,PIC_CHARS *pc,char *tfno)
{
  *tfno=0;
  if (*dest_dir)
  {
    strcpy(tfno,dest_dir);
    if (RCHAR(tfno)!=DIR_SEPARATOR) sprintf(tfno,"%s%c",tfno,DIR_SEPARATOR);
    if (prefer.split_destdir) sprintf(tfno,"%s%s%c",tfno,sattype(pc->sat_src),DIR_SEPARATOR);
    if (!make_dir(tfno));
//      Create_Message("Info","Created new dir\n%s.",tfno);
  }
}


void make_filename1(char *dest_dir,PIC_CHARS *pc,char *ext,char *tfno,GENMODES *modes,gboolean do_split)
{
  make_destdir1(dest_dir,pc,tfno);

  if ((modes) && (modes->image_oformat=='t')) return;

  strcat(tfno,pc->fno);
  if (modes->ofile) return;
  if (ext)
  {
    strcat(tfno,ext);
  }
  else if (modes)
  {
    if (modes->image_oformat==PIC_RAH)
    {
      strcat(tfno,".rah");
    }
    else if ((modes->image_oformat==PIC_JPEG) || (modes->image_oformat==PIC_CJPEG))
    {
      strcat(tfno,".jpg");
    }
    else if (modes->image_oformat==PIC_PGM8)
    {
      strcat(tfno,".pgm");
    }
    else if (modes->image_oformat==PIC_PGM)
    {
      if (pc->is_color)
      {
        strcat(tfno,".ppm");
      }
      else
      {
        strcat(tfno,".pgm");
      }
    }
  }
}


char *prepare_filmgen(char *dest_tmpdir,char *dest_tmpsavdir,GROUP *grp_sel,PIC_CHARS *pc,GENMODES *modes)
{
  char *tfno=NULL;
  char *ptfno;
  if (!(make_dir_hier(dest_tmpdir)))
  {
//      if (window)
//      {
//        Set_Entry(window,LAB_INFO,"Created dir. %s.",dest_tmpdir);
//      }
  }

  tfno=make_filename(dest_tmpdir,pc,NULL,modes,FALSE); /* generate in temp-dir */

/* Check if already available; move to temp-dir if so.
   Later check if already in temp-dir, then generation is skipped.
*/
  if ((ptfno=strrchr(tfno,DIR_SEPARATOR)))
  {
    char *fd1=NULL,*fd2=NULL;
    int w1=0,h1=0;
    sprintfd(&fd1,"%s%s",dest_tmpsavdir,ptfno+1);  // filename in sav dir

    /* Check if file has correct size. If so, move it to collect dir */
    get_jpegsize(fd1,&w1,&h1);                            // catch size
    if ((w1==pc->o_width) && (h1==pc->o_height))          // size equals what's expected?
    {
      sprintfd(&fd2,"%s%s",dest_tmpdir,ptfno+1);   // make filename in tmp-dir
      rename(fd1,fd2);                                    // move from sav dir to tmp dir
      grp_sel->done=TRUE;
    }
    freed(&fd1);
    freed(&fd2);
  }
  return tfno;
}
