/*******************************************************************
 * Copyright (C) 2003 R. Alblas 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 ********************************************************************/
/*
 *  more channels added (Himawari)
 *  sl->min_per_pic:30 -> 10 min (Himawari)
*/
#include "xrit2pic.h"
#include <string.h>

/* see #define nrchanlist 12 */
// onderstaand alleen gebruikt voor:
//  clrmap 'live' (namen moeten overeenkomen met wat in filenaam staat)
//  omrekenen kanaalnr naar naam, zie extract_anno_tay
//  in_satchanlist()
char *channellist_msg[]={"VIS006","VIS008","IR_016","IR_039","WV_062","WV_073",
                         "IR_087","IR_097","IR_108","IR_120","IR_134","HRV",NULL};

char *channellist_msglrit[]={"VIS006","IR_016","IR_039","WV_062","IR_108",NULL};

char *channellist_metlrit[]={"VIS007","WV_064","IR_115",NULL};

char *channellist_goeslrit[]={"VIS007","IR_107","IR_039","WV_066",NULL};

char *channellist_goslrit[]={"VIS01","WV03","IR04",NULL};

char *channellist_him[]={"B01","B02","VIS","B04","B05","B06","IR4","B09","IR3","B10",
                         "B11","B12","IR1","B14","IR2","B16",NULL};
                      
char *chanspectrlist_him[]={"B01_0047","B02_0051","VIS_0064","B04_0086","B05_016",
                            "B06_023" ,"IR4_039"  ,"B09_062","IR3_069" ,"B10_073",
                            "B11_086" ,"B12_096" ,"IR1_104" ,"B14_112" ,"IR2_124",
                            "B16_133" ,NULL};

gboolean is_foreign(char *sat)
{
  if (!strcmp(sat,"MTSAT1R"))  return TRUE;
  if (!strncmp(sat,"GOES",4))  return TRUE;
  if (!strncmp(sat,"MET",3))   return TRUE;
  if (!strncmp(sat,"NOAA",4))  return TRUE;
  if (!strncmp(sat,"METOP",5)) return TRUE;
  if (!strcmp(sat,"DWDSAT"))   return TRUE; 
  if (!strcmp(sat,"DK01"))     return TRUE; 
  if (!strcmp(sat,"BUFR"))     return TRUE; 
  return FALSE;
}

gboolean is_msg(char *sat)
{
  if ((strncmp(sat,"HMSG",4)) && (strncmp(sat,"LMSG",4))) return FALSE;
  return TRUE;
}

gboolean is_mfg(char *sat)
{
  if (strncmp(sat,"MET",3))   return FALSE;
  if (!strncmp(sat,"METO",4)) return FALSE;
  return TRUE;
}

gboolean is_othersat(char *sat)
{
  if (is_msg(sat))     return FALSE;
  if (is_mfg(sat))     return FALSE;
  if (is_foreign(sat)) return FALSE;
  return TRUE;
}

char **chan2strlist(SATLIST *cl)
{
  static char *chans[31];
  int n=0;
  forall_items(cl,cl)
  {
    if (n>=30) break;
    chans[n++]=cl->name;
  }
  chans[n]=NULL;
  return chans;
}


static void create_list_sats_msg(SATLIST **list)
{
  SATLIST *ilist=NULL,*sl,*sat,*chan;
  int ch;
/***************** HRIT *****************/
  sat=Create_Satlist(&ilist); sat->name="HMSG?"; sat->set_default=TRUE; sat->header="----- MSG HRIT  -----";
//  sl=Create_Satlist(&ilist);  sl->name="HMSG1"; sl->show_name="MSG1";
  sl=Create_Satlist(&ilist);  sl->name="HMSG2"; sl->show_name="MSG2";
  sl=Create_Satlist(&ilist);  sl->name="HMSG3"; sl->show_name="MSG3";
  sl=Create_Satlist(&ilist);  sl->name="HMSG4"; sl->show_name="MSG4";
  for (ch=0; channellist_msg[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_msg[ch];
  }

  for (sl=sat; sl; sl=sl->next)
  {
    sl->data_type=MSG_HRIT;
    sl->grp_name="HMSG";
    sl->chans=sat->chans;
    sl->min_per_pic=15;
    sl->subsat_lon=0.;
    sl->subsat_lon_defined=TRUE;
    sl->defmap_id=map_vis_hmsg;
    if (!sl->show_name) sl->show_name=sl->name;
  }

/***************** HRIT RSS *****************/
  sat=Create_Satlist(&ilist); sat->name="HMSG?_RSS";
//  sl=Create_Satlist(&ilist);  sl->name="HMSG1_RSS"; sl->show_name="MSG1 ";
  sl=Create_Satlist(&ilist);  sl->name="HMSG2_RSS"; sl->show_name="MSG2 ";
  sl=Create_Satlist(&ilist);  sl->name="HMSG3_RSS"; sl->show_name="MSG3 ";
  sl=Create_Satlist(&ilist);  sl->name="HMSG4_RSS"; sl->show_name="MSG4 ";
  for (ch=0; channellist_msg[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_msg[ch];
  }

  for (sl=sat; sl; sl=sl->next)
  {
    sl->data_type=MSG_HRIT;
    sl->grp_name="HMSG_RSS";
    sl->chans=sat->chans;
    sl->min_per_pic=5;
    sl->subsat_lon=9.5;
    sl->subsat_lon_defined=TRUE;
    sl->defmap_id=map_vis_hmsg;
    if (!sl->show_name) sl->show_name=sl->name;
  }

/***************** HRIT IODC *****************/
  sat=Create_Satlist(&ilist); sat->name="HMSG1_IODC";
  for (ch=0; channellist_msg[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_msg[ch];
  }
  for (sl=sat; sl; sl=sl->next)
  {
    sl->data_type=MSG_HRIT;
    sl->grp_name="HMSG_IODC";
    sl->chans=sat->chans;
    sl->min_per_pic=5;
    sl->subsat_lon=41.5;
    sl->subsat_lon_defined=TRUE;
    sl->defmap_id=map_vis_hmsg;
    if (!sl->show_name) sl->show_name=sl->name;
  }


/***************** LRIT *****************/
  sat=Create_Satlist(&ilist); sat->name="LMSG?"; sat->header="----- MSG LRIT -----";
//  sl=Create_Satlist(&ilist);  sl->name="LMSG1"; sl->show_name="MSG1  ";
  sl=Create_Satlist(&ilist);  sl->name="LMSG2"; sl->show_name="MSG2  ";
  sl=Create_Satlist(&ilist);  sl->name="LMSG3"; sl->show_name="MSG3  ";
  sl=Create_Satlist(&ilist);  sl->name="LMSG4"; sl->show_name="MSG4  ";
  for (ch=0; channellist_msglrit[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_msglrit[ch];
  }

  for (sl=sat; sl; sl=sl->next)
  {
    sl->data_type=MSG_LRIT;
    sl->grp_name="LMSG";
    sl->subsat_lon=0.;
    sl->subsat_lon_defined=TRUE;
    sl->chans=sat->chans;
    sl->defmap_id=map_vis_lmsg;
    if (!sl->show_name) sl->show_name=sl->name;
  }

// next doesn't exist?
/***************** LRIT RSS *****************/
  sat=Create_Satlist(&ilist); sat->name="LMSG?_RSS";
//  sl=Create_Satlist(&ilist);  sl->name="LMSG1_RSS"; sl->show_name="MSG1   ";
  sl=Create_Satlist(&ilist);  sl->name="LMSG2_RSS"; sl->show_name="MSG2   ";
  sl=Create_Satlist(&ilist);  sl->name="LMSG3_RSS"; sl->show_name="MSG3   ";
  sl=Create_Satlist(&ilist);  sl->name="LMSG4_RSS"; sl->show_name="MSG4   ";
  for (ch=0; channellist_msglrit[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_msglrit[ch];
  }

  for (sl=sat; sl; sl=sl->next)
  {
    sl->data_type=MSG_LRIT;
    sl->grp_name="LMSG_RSS";
    sl->subsat_lon=9.5;
    sl->subsat_lon_defined=TRUE;
    sl->chans=sat->chans;
    sl->defmap_id=map_vis_lmsg;
    if (!sl->show_name) sl->show_name=sl->name;
  }

/***************** Common for this group *****************/
  for (sl=ilist; sl; sl=sl->next)
  {
    sl->type=GEO;
    sl->use_in_showlist  =TRUE;
    sl->use_in_deletelist=FALSE;
  }

/***************** Add to total list *****************/
  if (*list)
  {
    for (sl=*list; ((sl) && (sl->next)); sl=sl->next);
    sl->next=ilist;
    ilist->prev=sl;
  }
  else
  {
    *list=ilist;
  }
}

/*****************MET first gen.*****************/
static void create_list_sats_mfg(SATLIST **list)
{
  SATLIST *ilist=NULL,*sl,*sat,*chan;
  int ch;
/***************** HRIT *****************/
  sat=Create_Satlist(&ilist); sat->name="LMET5"; sat->show_name="MET5"; sat->header="----- MFG -----";
  sl=Create_Satlist(&ilist);  sl->name="LMET6"; sl->show_name="MET6";
  sl=Create_Satlist(&ilist);  sl->name="LMET7"; sl->show_name="MET7";
  for (ch=0; channellist_metlrit[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_metlrit[ch];
  }

/***************** Common for this group *****************/
  for (sl=ilist; sl; sl=sl->next)
  {
    sl->data_type=MFG_LRIT;
    sl->grp_name="MFG";
    sl->type=GEO;
    sl->subsat_lon=57.5;
    sl->subsat_lon_defined=TRUE;
    sl->use_in_showlist  =TRUE;
    sl->use_in_deletelist=TRUE;
    sl->chans=sat->chans;
    if (!sl->show_name) sl->show_name=sl->name;
  }

/***************** Add to total list *****************/
  if (*list)
  {
    for (sl=*list; ((sl) && (sl->next)); sl=sl->next);
    sl->next=ilist;
    ilist->prev=sl;
  }
  else
  {
    *list=ilist;
  }
}

/*****************FOREIGN*****************/
static void create_list_sats_foreign_geo(SATLIST **list)
{
  SATLIST *ilist=NULL,*sl,*sat,*chan;
  int ch;
  // GOES9,GOES10: begraven
  sat=Create_Satlist(&ilist); sat->name="LGOES12"; sat->show_name="GOES12";  sat->header="----- GOES -----"; 
  sl=Create_Satlist(&ilist);  sl->name="LGOES13"; sl->show_name="GOES13";     
  sl=Create_Satlist(&ilist);  sl->name="LGOES14"; sl->show_name="GOES14";  
  sl=Create_Satlist(&ilist);  sl->name="LGOES15"; sl->show_name="GOES15";   
  sl=Create_Satlist(&ilist);  sl->name="LGOES16"; sl->show_name="GOES16";   
  for (ch=0; channellist_goeslrit[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_goeslrit[ch];
  }
  for (sl=sat; sl; sl=sl->next)
  {
    if (!strcasecmp(sl->name,"LGOES16"))  {sl->subsat_lon=-105.; sl->subsat_lon_defined=TRUE;}
    if (!strcasecmp(sl->name,"LGOES15"))  {sl->subsat_lon=-135.; sl->subsat_lon_defined=TRUE;}
//    if (!strcasecmp(sl->name,"LGOES14"))  {sl->subsat_lon=??; }
    if (!strcasecmp(sl->name,"LGOES13"))  {sl->subsat_lon= -75.1; sl->subsat_lon_defined=TRUE;}
    if (!strcasecmp(sl->name,"LGOES12"))  {sl->subsat_lon= -75.1; sl->subsat_lon_defined=TRUE;}
    sl->data_type=GOES_LRIT;
    sl->grp_name="GOES"; // was "GOS"
    sl->chans=sat->chans;
    if (!sl->show_name) sl->show_name=sl->name;
  }

// GOES direct, not via Eumetcast: different names
#ifdef EVEN_WEG
  sat=Create_Satlist(&ilist); sat->name="gos13"; sat->show_name="gos13";  sat->header="----- GOS -----"; 
  sl=Create_Satlist(&ilist);  sl->name="gos14"; sl->show_name="gos14";     
  sl=Create_Satlist(&ilist);  sl->name="gos15"; sl->show_name="gos15";     
  for (ch=0; channellist_goslrit[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_goslrit[ch];
  }
  for (sl=sat; sl; sl=sl->next)
  {
    sl->data_type=GOES_LRIT;
    sl->grp_name="GOES";
    sl->chans=sat->chans;
  }
#endif

// to add:
//    if (!strcasecmp(xh->satsrc,"DK02"))    xh->subsat_lon= 145.;
//    if (!strcasecmp(xh->satsrc,"DK03"))    xh->subsat_lon= 145.;
  sat=Create_Satlist(&ilist); sat->name="MTSAT1R";   sat->header="----- JMA -----"; 
  sl=Create_Satlist(&ilist);  sl->name ="JDK01";      sl->show_name="HIMAWARI"; 
  sl->min_per_pic=10; // 30;
  for (ch=0; channellist_him[ch]; ch++)
  {
    chan=Create_Satlist(&sl->chans);
    chan->name=channellist_him[ch];
  }
  for (sl=sat; sl; sl=sl->next)
  {
    sl->data_type=JMA_HRIT;
    sl->grp_name="JMA";
    sl->subsat_lon=145.;
    sl->subsat_lon_defined=TRUE;
    sl->defmap_id=map_hima_nc;
    if (!sl->show_name) sl->show_name=sl->name;
  }

/***************** Common for this group *****************/
  for (sl=ilist; sl; sl=sl->next)
  {
    sl->type=GEO;
    sl->use_in_showlist  =TRUE;
    sl->use_in_deletelist=TRUE;
  }

/***************** Add to total list *****************/
  if (*list)
  {
    for (sl=*list; ((sl) && (sl->next)); sl=sl->next);
    sl->next=ilist;
    ilist->prev=sl;
  }
  else
  {
    *list=ilist;
  }
}

/*****************FOREIGN*****************/
static void create_list_sats_foreign_old_geo(SATLIST **list)
{
  SATLIST *ilist=NULL,*sl,*sat,*chan;
  int ch;
  // GOES9,GOES10: begraven
  sat=Create_Satlist(&ilist); sat->name="LGOES9"; sat->show_name="GOES9";  sat->header="----- GOES old-----"; 
  sl=Create_Satlist(&ilist); sl->name="LGOES10"; sat->show_name="GOES10";   
  sl=Create_Satlist(&ilist); sl->name="LGOES11"; sat->show_name="GOES11";   
  sl=Create_Satlist(&ilist); sl->name="gos11"; sat->show_name="gos11";   
  sl=Create_Satlist(&ilist); sl->name="gos12"; sat->show_name="gos12";   
  for (ch=0; channellist_goeslrit[ch]; ch++)
  {
    chan=Create_Satlist(&sat->chans);
    chan->name=channellist_goeslrit[ch];
  }
  for (sl=sat; sl; sl=sl->next)
  {
    if (!strcasecmp(sl->name,"gos12"))    {sl->subsat_lon= -75.1; sl->subsat_lon_defined=TRUE;}
    if (!strcasecmp(sl->name,"gos11"))    {sl->subsat_lon=-135.0; sl->subsat_lon_defined=TRUE;}
    if (!strcasecmp(sl->name,"LGOES11"))  {sl->subsat_lon=-135.0; sl->subsat_lon_defined=TRUE;}
    if (!strcasecmp(sl->name,"LGOES10"))  {sl->subsat_lon=-135.0; sl->subsat_lon_defined=TRUE;}
    if (!strcasecmp(sl->name,"LGOES9"))   {sl->subsat_lon=-204.2; sl->subsat_lon_defined=TRUE;}
    sl->data_type=GOES_LRIT;
    sl->grp_name="GOES";
    sl->chans=sat->chans;
    if (!sl->show_name) sl->show_name=sl->name;
  }

/***************** Common for this group *****************/
  for (sl=ilist; sl; sl=sl->next)
  {
    sl->type=GEO;
    sl->use_in_showlist  =FALSE;
    sl->use_in_deletelist=FALSE;
  }

/***************** Add to total list *****************/
  if (*list)
  {
    for (sl=*list; ((sl) && (sl->next)); sl=sl->next);
    sl->next=ilist;
    ilist->prev=sl;
  }
  else
  {
    *list=ilist;
  }
}

/*****************POLAR*****************/
static void create_list_sats_polar(SATLIST **list)
{
  SATLIST *ilist=NULL,*sl,*sat;
  sat=Create_Satlist(&ilist); sat->name="NOAA";    sat->header="POLAR"; 
  sat=Create_Satlist(&ilist); sat->name="GAC";    
  sat=Create_Satlist(&ilist); sat->name="METOP-A";
  sat=Create_Satlist(&ilist); sat->name="METOP-B";
/***************** Common for this group *****************/
  for (sl=ilist; sl; sl=sl->next)
  {
    sl->type=POLAR;
    sl->use_in_showlist  =FALSE;
    sl->use_in_deletelist=TRUE;
  }

/***************** Add to total list *****************/
  if (*list)
  {
    for (sl=*list; ((sl) && (sl->next)); sl=sl->next);
    sl->next=ilist;
    ilist->prev=sl;
  }
  else
  {
    *list=ilist;
  }
}

/*****************OTHER*****************/
static void create_list_sats_other(SATLIST **list)
{
  SATLIST *ilist=NULL,*sl,*sat;
  sat=Create_Satlist(&ilist); sat->name="DWDSAT"; sat->header="OTHER"; 
  sat=Create_Satlist(&ilist); sat->name="BUFR";
  for (sl=ilist; sl; sl=sl->next)
  {
//    sl->type=;
    sl->use_in_showlist  =FALSE;
    sl->use_in_deletelist=TRUE;
  }

/***************** Add to total list *****************/
  if (*list)
  {
    for (sl=*list; ((sl) && (sl->next)); sl=sl->next);
    sl->next=ilist;
    ilist->prev=sl;
  }
  else
  {
    *list=ilist;
  }
}

#ifdef XXX
static void pri_satlist(SATLIST *sat)
{
  SATLIST *s,*c;
  for (s=sat; s; s=s->next)
  {
    printf("name=%-10s  grp_name=%-10s show_name=>%-10s< %d  showlis=%d  dellist=%d\n",
      s->name,
      (s->grp_name? s->grp_name : ""),
      (s->show_name? s->show_name : s->name),
      s->type,
      s->use_in_showlist,
      s->use_in_deletelist);
    for (c=s->chans; c; c=c->next) printf("  chan=%-10s\n",c->name);
  }
}
#endif

SATLIST *create_list_of_sats()
{
  SATLIST *list=NULL;
  create_list_sats_msg(&list);
  create_list_sats_mfg(&list);
  create_list_sats_foreign_geo(&list);
  create_list_sats_foreign_old_geo(&list);
  create_list_sats_polar(&list);
  create_list_sats_other(&list);
//pri_satlist(list);
  return list;
}

SATLIST *Get_Satlist_Item(SATLIST *list,SATLIST_ITEM item,char *str)
{
  SATLIST *sl;
  forall_items(list,sl)
  {
    switch(item)
    {
      case SATLIST_NAME:
        if ((str) && (!strcmp(str,sl->name))) return sl;
      break;
      case SATLIST_SHOW_NAME:
        if ((str) && (!strcmp(str,sl->show_name))) return sl;
      break;
      case SATLIST_DEFAULT:
        if (sl->set_default) return sl;
      break;
      default:
      break;
    }
  }
  return NULL;
}

float get_subsat_lon(SATLIST *list,char *satsrc)
{
  list=Get_Satlist_Item(list,SATLIST_NAME,satsrc);
  if ((list) && (list->subsat_lon_defined)) return list->subsat_lon;
  return NO_SATPOS;
}

// Construct satname from group. 
// Link between satname as received and satname as ID in progra.
// E.g. MSG can be HRIT and LRIT.
#define SNLEN 50
char *construct_satname(GROUP *grp)
{
  static char satname[SNLEN+1];
  if (!strncmp(grp->sat_src,"MSG",3))
    snprintf(satname,SNLEN,"%c%s",grp->h_or_l,grp->sat_src);
  else if (grp->h_or_l=='G')
    snprintf(satname,SNLEN,"GAC_%s",grp->sat_src);
  else if (!strncmp(grp->sat_src,"DK01",3))  // himawari
    snprintf(satname,SNLEN,"%c%s",grp->h_or_l,grp->sat_src);
  else if (!strncmp(grp->sat_src,"GOES",4))
    snprintf(satname,SNLEN,"%c%s",grp->h_or_l,grp->sat_src);
  else 
    strncpy(satname,grp->sat_src,SNLEN);
  return satname;
}
