/*******************************************************************
 * Copyright (C) 2003 R. Alblas 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 ********************************************************************/
/*******************************************************************
 * Main gui part of xrit2pic
 ********************************************************************/
#include <stdlib.h>
#include "xrit2pic.h"
#include "xrit2pic_defines.h"
#include "gtk/gtk.h"
#include "gdk/gdkkeysyms.h"

/* Buttons etc. main */
#define MENU_FILE     "/File   "
#define MENU_RELD     "File   /Reload    "

#define MENU_FILENAME "File   /Filenames selected"
#define MENU_FILEINFO "File   /Fileinfo selected"
#define MENU_FINF     "File   /Script selected"
#define MENU_FILEARCH "File   /Archive selected"
#define MENU_DELF     "File   /Delete selected"

#define MENU_DELOLD   "File   /Delete old"
#define MENU_DELTF    "File   /Delete temp. movie files"
#define MENU_OVERL    "File   /Show overlay files"
#define MENU_LUTS     "File   /Show LUT files"
#define MENU_SEPAR    "separator/"
#define MENU_QUIT     "File   /Quit"

#define MENU_EDIT  "/Edit "
#define MENU_PREFS  "Edit/Preferences"
#define MENU_SGUI   "Edit/Save gui state"


#define LAB_EUROPE   "!Europe"
#define LAB_FIXNAME   "Europe"

#define LAB_RECEIVE "New files"

#define PACK_MENU "!Packmenu"
#define LAB_FIXAREA "Area"

extern XRIT_DBASE dbase;
extern PREFER prefer;
extern GROUP *globgrp;
extern GLOBINFO globinfo;

static char gseldir[1000];  // static
static GtkCTree *globdlist;
void create_xritinfo(GROUP *igrp,GtkWidget *widget);


#define NTODO "!To do"
#define NDONE "!Done"
#define LAB_MOVESEL "Move selected"
void do_status(GtkWidget *widget,gpointer data)
{
  char *name=(char *)data;
  GROUP *grp;
  int ntop=0,ndone=0;
  gboolean move_selected=Get_Button(widget,LAB_MOVESEL);
  for (grp=globgrp; grp; grp=grp->next)
  {
    CHANNEL *chan;
    for (chan=grp->pro_epi; chan; chan=chan->next)
    {
      move_segmfiles(chan->pro,name,move_selected);
      move_segmfiles(chan->epi,name,move_selected);
    }
    for (chan=grp->chan; chan; chan=chan->next)
    {
      move_segmfiles(chan->pro,name,move_selected);
      move_segmfiles(chan->epi,name,move_selected);
      move_segmfiles(chan->segm,name,move_selected);
    }
  }
  count_files(globgrp,&ntop,&ndone);
  Set_Entry(widget,NTODO,"%d",ntop);
  Set_Entry(widget,NDONE,"%d",ndone);
}

void list_overlay(GtkWidget *widget);
void list_luts(GtkWidget *widget);
float show_info_sel(GROUP *);
void menu_func(GtkWidget *widget,gpointer data)
{
  GtkWidget *wnd=Find_Parent_Window(widget);
  char *name=(char *)data;

  if (!strcmp(name,MENU_FINF))
  {
    create_piclist(wnd,globgrp,'m');
/*
    float n;
    n=show_info_sel(globgrp);
    Create_Message("File info","Total filesize=%.0f\n(%.0f %c)",
       n,(n>1000000000? n/1000000000: n>1000000?n/1000000: n>1000?n/1000: n),
         (n>1000000000? 'G'         : n>1000000? 'M':      n>1000?'k'   :' '));
*/
  }
  if (!strcmp(name,MENU_FILENAME))
  {
    char *fnstr;
    fnstr=fn_selected(globgrp);
    if (*fnstr)
      Create_Message("Related files",fnstr);
    
  }

  if (!strcmp(name,MENU_FILEINFO))
  {
    create_xritinfo(globgrp,widget);  
  }

  if (!strcmp(name,MENU_FILEARCH))
  {
    char *str;
    Set_Entry(wnd,LAB_INFO,"");
    if ((str=Create_Entrychoice("Move","Move selected to archive")))
    {
      RESULT res;
      Set_Entry(wnd,LAB_INFO,"Move to arch...");
      gtk_clist_freeze((GtkCList *)dbase.main_tree);
      res=archive_selected(&globgrp,dbase.main_tree,str);
      Set_Entry(wnd,LAB_INFO,"Move to arch Done. Reload...");
      gtk_clist_thaw((GtkCList *)dbase.main_tree);
      globgrp=Load_List_all(globgrp,dbase.main_tree,widget,NULL);
      Load_CTree_Dirlist(globdlist,NULL,globinfo.src_archdir,3);
      if (res.err)
      {
        Create_Message("error", "failed to move %d files (out of %d).",res.failed,res.success+res.failed);
        Set_Entry(wnd,LAB_INFO,"Move to archive failed.");
      }
      else
      {
        Set_Entry(wnd,LAB_INFO,"Move to archive ready.");
      }
    }
    else
    {
      Set_Entry(wnd,LAB_INFO,"Move to archive canceled.");
    }
  }

  if (!strcmp(name,MENU_DELOLD))
  {
    int n;
    char age[40];
    if (prefer.roundday)
      sprintf(age,"%d days",prefer.deldaymin[0]);
    else
      sprintf(age,"%d days, %d hours",prefer.deldaymin[0],prefer.deldaymin[1]);

    n=delete_old(&globgrp,NULL,prefer.deldaymin,prefer.deldaymax,prefer.roundday);
    if (n)
    {
      n=Create_Choice("Warning",2,"Yes","No!","Delete %d groups (age: %s, < %d days old). Proceed?",
                                     n,age,prefer.deldaymax);
      if (n==1)
      {
        gtk_clist_freeze((GtkCList *)dbase.main_tree);
        n=delete_old(&globgrp,dbase.main_tree,prefer.deldaymin,prefer.deldaymax,prefer.roundday);
        gtk_clist_thaw((GtkCList *)dbase.main_tree);

        Set_Entry(wnd,LAB_INFO,"Deleted %d files.",n);
      }
    }
    else
    {
      if ((prefer.deldaymin[0]) || (prefer.deldaymin[1]))
      {
        if (prefer.deldaymax)
          Create_Message("info","Nothing to delete  (age: %s...%d days).",age,prefer.deldaymax);
        else
          Create_Message("info","Nothing to delete  (age: > %s).",age);
      }
      else
      {
        Create_Message("info","Disabled (age=%d days, %d hours)",prefer.deldaymin[0],prefer.deldaymin[1]);
      }
    }
  }

  if (!strcmp(name,MENU_DELF))
  {
    int n;
    n=delete_selected(&globgrp,NULL);
    if (n)
    {
      n=Create_Choice("Warning",2,"Yes","No!","Delete %d files. Proceed?",n);
      if (n==1)
      {
        gtk_clist_freeze((GtkCList *)dbase.main_tree);
        Set_Entry(wnd,LAB_INFO,"Deleting....");
        n=delete_selected(&globgrp,dbase.main_tree);
        gtk_clist_thaw((GtkCList *)dbase.main_tree);
        Set_Entry(wnd,LAB_INFO,"Deleted %d files.",n);
      }
      else if (n==2)
      {
        Set_Entry(wnd,LAB_INFO,"Nothing deleted.");
      }
      else 
      {
        Set_Entry(wnd,LAB_INFO,"(Aborted)");
      }
    }
  }

  if (!strcmp(name,MENU_DELTF))
  {
    int n;
    n=remove_dircontent(globinfo.dest_tmpdir,"*.jpg",FALSE);
    if (n)
    {
      n=Create_Choice("Info",2,"Yes","No","%d items will be removed \nfrom %s. \nDo it?",n,globinfo.dest_tmpdir);
      if (n==1)
      {
        n=remove_dircontent(globinfo.dest_tmpdir,"*.jpg",TRUE);
        Set_Entry(widget,LAB_RECINFO,"Removed %d items.",n);
        Set_Entry(widget,LAB_INFO,"Removed %d items.",n);
      }
    }
    else
    {
      Set_Entry(widget,LAB_RECINFO,"Nothing to remove in %s.",globinfo.dest_tmpdir);
      Set_Entry(widget,LAB_INFO,"Nothing to remove in %s.",globinfo.dest_tmpdir);
    }
  }

  if (!strcmp(name,MENU_OVERL))
  {
    list_overlay(widget);
  }

  if (!strcmp(name,MENU_LUTS))
  {
    list_luts(widget);
  }

  if (!strcmp(name,MENU_RELD))
  {
    Set_Button(widget,LAB_CRLOAD,FALSE);  // Stop cont. updating.
    Set_Button(widget,LAB_EXPCOL,FALSE);

/* set to 'All'; otherwise tree not properly shown (to be fixed) */
    globinfo.vis_mode=S_all; 
    if ((Get_Optionsmenu(widget,LAB_VIS))!=0) /* to prevent unnecess. redraw */
      Set_Optionsmenu(widget,LAB_VIS,0); 

    globgrp=Load_List_all(globgrp,dbase.main_tree,widget,NULL);
    show_tree(dbase.main_tree,globgrp,TRUE,TRUE);  /* redraw tree */
    Load_CTree_Dirlist(globdlist,NULL,globinfo.src_archdir,3);
  }
  
  if (!strcmp(name,MENU_3DIM))
  {
    globinfo.dim3=Get_Button(wnd,MENU_3DIM);
    Sense_Button(wnd,LAB_SHFT3D,globinfo.dim3);
  }

  if (!strcmp(name,MENU_IRNORM))
  {
  }

  if (!strcmp(name,MENU_TEMPC))
  {
    globinfo.spm.map_temp=Get_Button(wnd,MENU_TEMPC);
  }
  if (!strcmp(name,MENU_TEMPG))
  {
    globinfo.spm.map_temp_G_mA=Get_Button(wnd,MENU_TEMPG);
  }

  if (!strcmp(name,MENU_LUT))
  {
    globinfo.lut.use=Get_Button(wnd,MENU_LUT);
  }
  if (!strcmp(name,MENU_SLUT))
  {
    select_lut(widget);
  }

  if (!strcmp(name,MENU_FIRE))
  {
    globinfo.spm.fire_detect=Get_Button(wnd,MENU_FIRE);
  }

  if (!strcmp(name,MENU_EVIEW))
  {
    globinfo.view_exported=Get_Button(wnd,MENU_EVIEW);
  }
  if (!strcmp(name,MENU_LONLAT))
  {
    globinfo.pm.ol.add_lonlat=Get_Button(wnd,MENU_LONLAT);
  }
  if (!strcmp(name,MENU_CITIES))
  {
    globinfo.pm.ol.add_cities=Get_Button(wnd,MENU_CITIES);
  }
  if (!strcmp(name,MENU_MARK))
  {
    globinfo.pm.ol.add_marks=Get_Button(wnd,MENU_MARK);
  }

  if (!strcmp(name,MENU_AVLIN))
  {
    globinfo.avhrr_lin=Get_Button(wnd,MENU_AVLIN);
  }
  if (!strcmp(name,MENU_GEOGR_NR))
  {
    globinfo.gmap=normal;
  }
  if (!strcmp(name,MENU_GEOGR_PC))
  {
    globinfo.gmap=plate_carree;
  }
  if (!strcmp(name,MENU_GEOGR_MT))
  {
    globinfo.gmap=mercator;
  }
  if (!strcmp(name,MENU_GEOGR_PN))
  {
    globinfo.gmap=polar_n;
  }
  if (!strcmp(name,MENU_GEOGR_PS))
  {
    globinfo.gmap=polar_s;
  }

  globinfo.area_nr=Get_Optionsmenu(widget,LAB_FIXAREA);
  // use area name instead of order number; 
  //   get nr. from name instead of position in menu
  {
    char *str=soption_menu_get_history(Find_Widget(widget,LAB_FIXAREA));
    if (str)
    {
      int i;
      for (i=0; i<NRGEODEFS; i++)
      {
        if (!strcmp(prefer.geoarea[i].part_name,str))
        {
          globinfo.area_nr=i+1;
          break;
        }
      }
    }
  }
}

void pref_wnd(GtkWidget *widget,gpointer data)
{
  char *name=(char *)data;

  if (!strcmp(name,MENU_SGUI))
  {
    save_guistate_all(widget);
    Create_Message("Info","Gui state saved.");
  }
  
  if (!strcmp(name,MENU_PREFS))
    prefwindow(widget,gseldir);
}

/*********************************************************************/
#ifndef DEBUG_KLAD
#define DEBUG_KLAD 0
#endif

#define LAB_FIXMAP "!Fixed"
#define LAB_NRGB    "nrgb"
#define LAB_NRGBDN  "nrgb_dn"
#define LAB_AIRMASS "airm"
#define LAB_DUST    "dust"
#define LAB_NFOG    "fog Night"
#define LAB_DFOG    "fog Day"
#define LAB_EVIEW   "eview"
#define LAB_UCLD    "mu_cloud"
#define LAB_UDUST   "mu_dust"
#define LAB_UASH    "mu_ash"
#define LAB_UNIGHT  "mu_night"
#define LAB_UDAY    "mu_day"
#define LAB_CNVSTRM "conv_storm"
#define LAB_SNOWFOG "snow fog"
#define LAB_CHLAY "!overlay"
#define LAB_COAST "Coast"
#define LAB_COUNTR "Cntry"
#define LAB_LATLON "Latlon"
#define LAB_BOTH "All   "              // extra space because of LAB_VISA!
/*******************************************************
 * Create the gui
 *******************************************************/
void create_gui(int argc,char **argv)
{
  GtkWidget *menu,*menubut[4];
  GtkWidget *wnd,*wz[10],*wa,*wb,*wc,*wd,*we,*wf;
#if DEBUG_KLAD==1
  GtkWidget *wdbg;
#endif
  GtkCTree *ctree;
  GtkCList *dlist;
  SATLIST *sl;
  #ifdef __GTK_20__
  gtk_disable_setlocale();  // prevent changing . into , !
  #endif
  gtk_init(&argc, &argv);
  gdk_rgb_init();

  globinfo.move_to_done=TRUE;
  globinfo.dirsel.selrow=-1;
  strcpy(gseldir,prefer.pl.src_dir);
  set_fontsize(prefer.font_size);
  wnd=Create_Window(NULL,prefer.wndwidth,prefer.wndheight,LAB_MAIN,gtk_main_quit);

/* Menu */

  menu=Create_Menu(wnd,MENU_FILE           ,NULL        ,BUTTON,
                         MENU_RELD         ,menu_func   ,BUTTON,
                         MENU_FILENAME     ,menu_func   ,BUTTON,
                         MENU_FILEINFO     ,menu_func   ,BUTTON,
                         MENU_FINF         ,menu_func   ,BUTTON,
                         MENU_FILEARCH     ,menu_func   ,BUTTON,
                         MENU_SEPAR        ,NULL        ,BUTTON,
                         MENU_DELF         ,menu_func   ,BUTTON,
                         MENU_DELOLD       ,menu_func   ,BUTTON,
                         MENU_DELTF        ,menu_func   ,BUTTON,
                         MENU_SEPAR        ,NULL        ,BUTTON,
                         MENU_OVERL        ,menu_func   ,BUTTON,
                         MENU_LUTS        ,menu_func   ,BUTTON,

                         MENU_SEPAR        ,NULL        ,BUTTON,
                         MENU_QUIT         ,Close_Window,BUTTON,
                       MENU_EDIT           ,NULL        ,BUTTON,
                         MENU_PREFS        ,pref_wnd    ,BUTTON,
                         MENU_SGUI         ,pref_wnd    ,BUTTON,
                       MENU_GMAP           ,NULL        ,BUTTON,
                         MENU_AVLIN        ,menu_func   ,CHECK,
                         MENU_GEOGR        ,menu_func   ,BUTTON,
                         MENU_GEOGR_NR     ,menu_func   ,RADIO,
                         MENU_GEOGR_PC     ,menu_func   ,RADIO,
                         MENU_GEOGR_MT     ,menu_func   ,RADIO,
                         MENU_GEOGR_PN     ,menu_func   ,RADIO,
                         MENU_GEOGR_PS     ,menu_func   ,RADIO,
                       MENU_VIEW           ,NULL        ,BUTTON,
                         MENU_MARK         ,menu_func   ,CHECK,
                         MENU_CITIES       ,menu_func   ,CHECK,
                         MENU_LONLAT       ,menu_func   ,CHECK,
                         MENU_EVIEW        ,menu_func   ,CHECK,
                         MENU_3DIM         ,menu_func   ,CHECK,
                         MENU_FIRE         ,menu_func   ,CHECK,
                         MENU_IRNORM       ,menu_func   ,RADIO,
                         MENU_TEMPG        ,menu_func   ,RADIO,
                         MENU_TEMPC        ,menu_func   ,RADIO,
                         MENU_LUT          ,menu_func   ,RADIO,
                         MENU_SLUT         ,menu_func   ,BUTTON,
                       NULL);

menubut[0]=menubut[1]=menubut[2]=menubut[3]=NULL;
  menubut[1]=Create_Optionmenu(LAB_FIXAREA,menu_func,0,0);
  {
    int i,j;
    char *tmp[NRGEODEFS+1];
    j=0;
    tmp[j++]="Full";
    for (i=0; i<NRGEODEFS; i++)
    {
      if (*prefer.geoarea[i].part_name)
      {
        tmp[j++]=prefer.geoarea[i].part_name;
      }
    }
    Add_Options(menubut[1],LAB_FIXAREA,menu_func,0,tmp,j,0);
  }
/*
  menubut[2]=Create_Optionmenu(LAB_FIXMAP,menu_func,0,
                           LAB_NRGB,LAB_NRGBDN,LAB_AIRMASS,LAB_DUST,LAB_EVIEW,LAB_NFOG,LAB_DFOG,
                           LAB_UCLD,LAB_UDUST,LAB_UASH,LAB_UNIGHT,LAB_UDAY,
                           LAB_CNVSTRM,LAB_SNOWFOG,
                           0);

  menubut[3]=Create_Optionmenu(LAB_CHLAY,menu_func,1,LAB_COAST,LAB_COUNTR,LAB_LATLON,LAB_BOTH,0);
*/
  menubut[1]=Pack("",'h',menubut[1],1,NULL);
  Set_Widgetcolor(menubut[1],'b',0,0,0);

  menubut[0]=Pack(NULL,'h',menubut[1],1,menubut[2],1,menubut[3],1,NULL);

  menu=Pack(PACK_MENU,'h',menu,1,menubut[0],1,NULL);
  wa=nb_main(&ctree);
  dbase.main_tree=ctree;

/* ---------------- Record TAB ---------------- */
  wb=nb_record();

/* ---------------- File manager TAB ---------------- */
  wd=nb_filemngr(&dlist,ctree);
  globdlist=(GtkCTree *)dlist;

/* ---------------- DIR Select TAB ---------------- */
  wc=nb_dirsel(ctree,dlist,gseldir);   // MUST be after nb_filemngr!

  we=nb_expmngr();

/* ---------------- Preferences TAB ---------------- */
//  we=nb_prefs(clist,gseldir);


/* ---------------- Program info TAB ---------------- */
  wf=nb_proginfo(globinfo.releasenr);

#if DEBUG_KLAD==1
  wdbg=nb_debug();
#endif

  wz[1]=Create_Notebook(NULL,GTK_POS_TOP,
                     "Main "             ,wa,
                     "Record"            ,wb,
                     "Received "         ,wc,
                     "Archive"           ,wd,
                     "Exported"          ,we,
                     "Program info"      ,wf,
#if DEBUG_KLAD==1
                     "Debug"             ,wdbg,
#endif
                     NULL);

  wz[0]=SPack(NULL,"v",menu,"1",wz[1],"ef1",NULL);
  gtk_container_add(GTK_CONTAINER(wnd),wz[0]);
  gtk_widget_show_all(wnd);

  Read_PrefDirlist(&globinfo.dirsel,&prefer); // afgeleide dirs al bepaald in xrit2pic.c

  define_and_load_srcdir(wnd,wc);

  gtk_widget_hide((Find_Widget(wnd,LAB_MORE))->parent);

  gtk_window_set_default_size((GtkWindow *)wnd,1,1); /* to force that space of hidden arts is removed */
  search_file(GPREFFILE,prefer.gui_inifile,
              prefer.cur_dir,prefer.home_dir,prefer.prog_dir);

  if ((sl=Get_Satlist_Item(globinfo.satlist,SATLIST_DEFAULT,globinfo.pr.lv_sat)))
      Set_Local_Button(Find_Widget(wnd,LAB_SHOWSAT),sl->show_name,TRUE);

  Set_Button(wnd,MENU_AVLIN,globinfo.avhrr_lin);  /* Set default linearize for AVHRR */

  if (prefer.enable_restore_guistate)
  {
    if (*prefer.gui_inifile) printf("Reading gui init-file %s..\n",prefer.gui_inifile);
    restore_guistate_fromfile(wa,prefer.gui_inifile);
  }
  else
  {
    gtk_widget_hide(Find_Widget(wnd,MENU_SGUI));
  }

  Set_Entry(wnd,LAB_INFO,"");     /* don't restore! */
  Set_Entry(wnd,LAB_RECINFO,"");  /* don't restore! */
  Set_Entry(wnd,LAB_NUPDATE,"");  /* don't restore! */
  switch(globinfo.gmap)
  {
    case normal      : Set_Button(wnd,MENU_GEOGR_NR,TRUE); break;
    case plate_carree: Set_Button(wnd,MENU_GEOGR_PC,TRUE); break;
    case mercator    : Set_Button(wnd,MENU_GEOGR_MT,TRUE); break;
    case polar_n     : Set_Button(wnd,MENU_GEOGR_PN,TRUE); break;
    case polar_s     : Set_Button(wnd,MENU_GEOGR_PS,TRUE); break;
    case polar_cn     :  break; // te doen
    case polar_cs     :  break; // te doen
  }
  Set_Button(wnd,MENU_LONLAT ,globinfo.pm.ol.add_lonlat);
  Set_Button(wnd,MENU_CITIES ,globinfo.pm.ol.add_cities);
  Set_Button(wnd,MENU_MARK ,globinfo.pm.ol.add_marks);

  Set_Button(wnd,MENU_LUT,globinfo.lut.use);
  Set_Button(wnd,prefer.pr.lv_sat,TRUE);
  pref_to_gui(wnd,&globinfo.dirsel,&prefer);
  gtk_main();
}

static GtkCTree *ctree;
static GtkCTreeNode *sel_node;
static void func(GtkWidget *widget,gpointer data)
{
  char *name=(char *)data;
  if (!strcmp(name,LAB_EXPCOL))
  {
    Update_Togglelabel(widget);
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
      gtk_ctree_expand_recursive(ctree,sel_node);
    else
      gtk_ctree_collapse_recursive(ctree,sel_node);
  }
}

static void sel_made(GtkWidget *widget,gpointer data)
{
  sel_node=(GtkCTreeNode *)data;
}

#define LAB_EXPCOL "Expand/Collapse"
#define LENSTR 200
void create_xritinfo(GROUP *igrp,GtkWidget *widget)
{
  GtkWidget *wnd,*wb[3];
  GtkCTreeNode *gn,*cn,*sn,*hn,*hn2;
  char str[LENSTR];
  char *tmphdr[4];
  char *tmp[4];
  int i;
  GROUP *grp;
  CHANNEL *chan;
  SEGMENT *segm;
  sel_node=NULL;

  tmphdr[0]="";
  for (grp=igrp; grp; grp=grp->next)
  {
    if (grp->nselected) break;
  }
  if (!grp) grp=igrp;
  wnd=Create_Window(Find_Parent_Window(widget),500,300,grp->id,NULL);
//  wnd=Create_Window(NULL,500,300,"Xrit header info",NULL);
  if (!wnd) return;

  ctree=Create_CTree("X",sel_made,NULL,NULL,NULL,NULL,1,tmphdr);
  wb[1]=Create_Toggle(LAB_EXPCOL,func,FALSE);
  wb[0]=Pack(NULL,'v',GTK_WIDGET(ctree)->parent,1,wb[1],1,NULL);
  gtk_container_add(GTK_CONTAINER(wnd),wb[0]);
  gtk_widget_show(wnd);
  gtk_clist_freeze((GtkCList *)ctree);
  gn=cn=sn=hn=hn2=NULL;
  for (grp=igrp; grp; grp=grp->next)
  {
    if (grp->nselected)
    {
      tmp[0]="Group";
      gn=Add_CLeaf(ctree,NULL,tmp);
      if ((grp->chan) && (grp->chan->segm))
      {
        snprintf(str,LENSTR,"Sub-sat position: lon=%.2f",grp->chan->segm->xh.subsat_lon);
        tmp[0]=str;
        cn=Add_CLeaf(ctree,gn,tmp);
      }
      if (grp->pro_epi)
      {
        if ((segm=grp->pro_epi->pro))
        {
          snprintf(str,LENSTR,"Prologue");
          tmp[0]=str;
          cn=Add_CLeaf(ctree,gn,tmp);
          sprintf(str,"  File=%s",segm->fn);
          tmp[0]=str;
          Add_CLeaf(ctree,cn,tmp);
        }
        if ((segm=grp->pro_epi->epi))
        {
          snprintf(str,LENSTR,"Epilogue");
          tmp[0]=str;
          cn=Add_CLeaf(ctree,gn,tmp);
          sprintf(str,"  File=%s",segm->fn);
          tmp[0]=str;
          Add_CLeaf(ctree,cn,tmp);
        }
      }
    }
    for (chan=grp->chan; chan; chan=chan->next)
    {
      int nrsegm=0;
      if ((grp->nselected) || (chan->nselected))
      {
        int width=0,height=0;
        for (segm=chan->segm; segm; segm=segm->next)
        {
          width=chan->segm->xh.nc;
          height+=chan->segm->xh.nl;
        }
//if (chan->Cal_Offset[0]>10.) printf("!! %f\n",chan->Cal_Offset[0]);
        snprintf(str,LENSTR,"Channel %s  %d x %d",chan->chan_name,width,height);
        tmp[0]=str;
        cn=Add_CLeaf(ctree,gn,tmp);
        snprintf(str,LENSTR,"Cal_Offset %f",chan->Cal_Offset[0]);
        tmp[0]=str;
        Add_CLeaf(ctree,cn,tmp);
        snprintf(str,LENSTR,"Cal_Slope %f",chan->Cal_Slope[0]);
        tmp[0]=str;
        Add_CLeaf(ctree,cn,tmp);

        if ((segm=chan->pro))
        {
          snprintf(str,LENSTR,"Prologue");
          tmp[0]=str;
          sn=Add_CLeaf(ctree,cn,tmp);
          sprintf(str,"  File=%s",segm->fn);
          tmp[0]=str;
          Add_CLeaf(ctree,sn,tmp);
        }
      }
      for (segm=chan->segm; segm; segm=segm->next)
      {
        FILE *fp=NULL;
        nrsegm++;
        if ((!grp->nselected) && (!chan->nselected) && (!segm->nselected)) continue;

        // don't open for METOP; may be too many files!
        if (segm->xh.xrit_frmt!=METOP)
        {
          fp=open_xritimage(segm->pfn,&segm->xh,segm->xh.xrit_frmt,
            (segm==chan->segm? segm->chan : NULL));
        }
        snprintf(str,LENSTR,"Segment %d",segm->xh.segment);
        tmp[0]=str;
        sn=Add_CLeaf(ctree,cn,tmp);
        sprintf(str,"  File=%s",segm->fn);
        tmp[0]=str;
        Add_CLeaf(ctree,sn,tmp);
        {
          switch(segm->xh.xrit_frmt)
          {
            case EXRIT: case JMA: case NXRIT: case N2XRIT: case UNKDTYPE:
              if (!fp) break;
              snprintf(str,LENSTR,"  coff=%d, cfac=%d, loff=%d, lfac=%d  nc=%d  nl=%d  start=%d end=%d",
                segm->xh.coff,segm->xh.cfac,segm->xh.loff,segm->xh.lfac,segm->xh.nc,segm->xh.nl,
                segm->xh.seq_start,segm->xh.seq_end);
              tmp[0]=str;
              Add_CLeaf(ctree,sn,tmp);
              sprintf(str,"  Headers");
              tmp[0]=str;
              hn=Add_CLeaf(ctree,sn,tmp);
              {
                unsigned char l[100];
                int type,len,hdr_len;
                rewind(fp);
                fread(l,16,1,fp);
                type=l[0];
                len=(l[1]<<8)+l[2];
                if (type==0)
                {
                  hdr_len=(l[4]<<24)+(l[5]<<16)+(l[6]<<8)+l[7];
                  rewind(fp);
                  do
                  {
                    char *stype="";
                    fread(l,3,1,fp);
                    type=l[0];
                    len=(l[1]<<8)+l[2];
                    switch(type)
                    {
                      case   0: stype=" >>> Primary Header";             break;
                      case   1: stype=" >>> Image Structure";            break;
                      case   2: stype=" >>> Image Navigation";           break;
                      case   3: stype=" >>> Image Data Function";        break;
                      case   4: stype=" >>> Annotation";                 break;
                      case   5: stype=" >>> Time Stamp";                 break;
                      case   6: stype=" >>> Ancillary Text";             break;
                      case   7: stype=" >>> Key Header";                 break;
                      case 128: stype=" >>> Segment Identification";     break;
                      case 129: stype=" >>> Image Segment Line Quality"; break;
                      case 131:
                        switch(segm->xh.xrit_frmt)
                        {
                          case NXRIT  : stype=" >>> Rice Compression record"; break;
                          case N2XRIT : stype=" >>> Rice Compression record"; break;
                          case JMA    : stype=" >>> Image Observation Time";   break;
                          default     : stype=" >>> Unknown type";            break;
                        }
                      break;
                      case 132:
                        switch(segm->xh.xrit_frmt)
                        {
                          case JMA    : stype=" >>> Image Quality Information"; break;
                          default     : stype=" >>> Unknown type";             break;
                        }
                      break;
                      default : stype=" >>> Unknown type"; break;
                    }
                    sprintf(str,"type=%4d  len=%5d  %s         [fp=%4lx]",type,len,stype,ftell(fp)-3);
                    tmp[0]=str;
                    hn2=Add_CLeaf(ctree,hn,tmp);

                    if (type==1)
                    {
                      sprintf(str,"w*h=[%d,%d]  d=%d",segm->xh.nc,segm->xh.nl,segm->xh.nb);
                      tmp[0]=str;
                      Add_CLeaf(ctree,hn2,tmp);
                    }

                    if ((type==3) && (chan->cal.caltbl[0]))
                    {
                      int last=chan->cal.nrcalpoints-1;
                      if ((last>1) && (chan->cal.caltbl[1][last]==chan->cal.caltbl[1][last-1])) last--;
                      sprintf(str,"Calibration: %d points;",last+1);
                      sprintf(str,"%s %s; ",str,(chan->cal.caltbl_type=='k'? "Kelvin" : "percent"));
                      if (chan->cal.caltbl[0])
                      { 
                        sprintf(str,"%s [%.0f,%f] ... [%.0f,%f]",str,
                          chan->cal.caltbl[0][0],chan->cal.caltbl[1][0],
                          chan->cal.caltbl[0][last],chan->cal.caltbl[1][last]);
                      }
                      tmp[0]=str;
                      Add_CLeaf(ctree,hn2,tmp);
                    }

                    if ((type==131) && (segm->xh.xrit_frmt==JMA))
                    {
                      char *p1,*p2;
                      char *s=NULL;
                      if ((len<1000) && ((s=calloc(len,1))))
                      {
                        fread(s,len-3,1,fp);
                        fseek(fp,-1*(len-3),SEEK_CUR);
                        while ((p1=strchr(s,'\r'))) *p1='\n';
                        p1=s;
                        while ((p2=strchr(p1,'\n')))
                        {
                          *p2=0;
                          tmp[0]=p1;
                          Add_CLeaf(ctree,hn2,tmp);
                          p1=p2+1;
                        }
                        free(s);
                      }
                    }

                    strcpy(str,"hexdump: ");
                    fseek(fp,-3,SEEK_CUR);
                    for (i=0; i<MIN(len,16); i++)
                    {
                      sprintf(str,"%s %02x",str,fgetc(fp));
                    }
                    if (len>16) sprintf(str,"%s .... (%d more)",str,len-16);
                    tmp[0]=str;
                    Add_CLeaf(ctree,hn2,tmp);
                    fseek(fp,len-MIN(len,16),SEEK_CUR);
//                    fseek(fp,len-3,SEEK_CUR);
                    hdr_len-=len;
                  } while (hdr_len>0);
                }
              }
            break;
            case METOP:
              if (segm->orbit.duration_of_product)
              {
                sprintf(str,"duration: %d",segm->orbit.duration_of_product);
                Add_CLeaf(ctree,sn,tmp);

                strcpy(str,"Position");
                tmp[0]=str;
                hn=Add_CLeaf(ctree,sn,tmp);
                sprintf(str,"Start: (%.2f,%.2f)  end: (%.2f,%.2f)",
                  segm->orbit.subsat_start.lat,segm->orbit.subsat_start.lon,
                  segm->orbit.subsat_end.lat,segm->orbit.subsat_end.lon);
                tmp[0]=str;
                Add_CLeaf(ctree,hn,tmp);

                sprintf(str,"orbit_start: %d",segm->orbit.orbit_start);
                Add_CLeaf(ctree,hn,tmp);
                sprintf(str,"epoch_year: %d",segm->orbit.epoch_year);
                Add_CLeaf(ctree,hn,tmp);
                sprintf(str,"epoch_day: %.2f",segm->orbit.epoch_day);
                Add_CLeaf(ctree,hn,tmp);
                sprintf(str,"eccentricity: %.2f",segm->orbit.eccentricity);
                Add_CLeaf(ctree,hn,tmp);
                sprintf(str,"inclination: %.2f",segm->orbit.inclination);
                Add_CLeaf(ctree,hn,tmp);
                sprintf(str,"perigee: %.2f",segm->orbit.perigee);
                Add_CLeaf(ctree,hn,tmp);
                sprintf(str,"raan: %.2f",segm->orbit.raan);
                Add_CLeaf(ctree,hn,tmp);
                sprintf(str,"anomaly: %.2f",segm->orbit.anomaly);
                Add_CLeaf(ctree,hn,tmp);
              }
            break;
            default:
            break;
          } // switch
          if (fp) fclose(fp);
        }
        freed(&segm->xh.img_obs_time);
      }
    }
    if ((grp->chan) && (grp->chan->segm))
    {
      if ((grp->nselected) || (grp->chan->nselected) || (grp->chan->segm->nselected))
      {
        switch(grp->chan->segm->xh.xrit_frmt)
        {
          case MHRPT: case NHRPT:
            snprintf(str,LENSTR,"Kepler");
            tmp[0]=str;
            hn=Add_CLeaf(ctree,gn,tmp);

            snprintf(str,LENSTR,"epoch_year %d",grp->pc.kepler.epoch_year);
            tmp[0]=str;
            Add_CLeaf(ctree,hn,tmp);
            sprintf(str,"epoch_day: %.2f",grp->pc.kepler.epoch_day);
            Add_CLeaf(ctree,hn,tmp);
            sprintf(str,"decay: %.8f",grp->pc.kepler.decay_rate);
            Add_CLeaf(ctree,hn,tmp);
            sprintf(str,"inclination: %.2f",R2D(grp->pc.kepler.inclination));
            Add_CLeaf(ctree,hn,tmp);
            sprintf(str,"raan: %.2f",R2D(grp->pc.kepler.raan));
            Add_CLeaf(ctree,hn,tmp);
            sprintf(str,"eccentricity: %.2f",R2D(grp->pc.kepler.eccentricity));
            Add_CLeaf(ctree,hn,tmp);
            sprintf(str,"perigee: %.2f",R2D(grp->pc.kepler.perigee));
            Add_CLeaf(ctree,hn,tmp);
            sprintf(str,"anomaly: %.2f",R2D(grp->pc.kepler.anomaly));
            Add_CLeaf(ctree,hn,tmp);
          break;
          default:
          break;
        }
      }
    }
  }
  gtk_clist_thaw((GtkCList *)ctree);
}
